<?php
function _addGetToLink($link, $params) {
    if (mb_substr_count($link, "?") == 0) {
        $link .= "?";
    } else {
        $link .= "&amp;";
    } 
    return$link . $params;
} 
function _addRestoreGetList($url, $array) {
    if (mb_substr_count($url, "?") == 0) {
        $url .= "?";
    } else {
        $url .= "&";
    } 
    foreach($array as$key => $item) {
        $url .= "_formData[" . $key . "]=" . $item . "&";
    } 
    return mb_substr($url, 0, mb_strlen($url)-1);
} 
if (_administration) {
    function _adminOutput() {
        global$_lang;
        $admintitle = $_lang['admin.defaulttitle'];
        if (isset($_GET['p'])) {
            $getp = _anchorStr($_GET['p']);
        } else {
            $getp = "index";
        } 
        $output = "";
        require(_indexroot . "admin/acore.php");
        if (_loginindicator and _loginright_administration) {
            $usermenu = '<a href="' . _indexroot . 'remote/logout.php?_return=admin">' . $_lang['usermenu.logout'] . ' [' . _loginname . ']</a>';
        } else {
            $usermenu = '<a href="./">' . $_lang['usermenu.guest'] . '</a>';
        } 
        if (_loginindicator and _loginright_administration) {
            $modules = array("index" => array($_lang['admin.menu.index'], true, null, array()), "content" => array($_lang['admin.menu.content'], _loginright_admincontent, null, array("content-move", "content-titles", "content-articles", "content-confirm", "content-movearts", "content-polls", "content-polls-edit", "content-boxes", "content-editsection", "content-editcategory", "content-delete", "content-editintersection", "content-articles-list", "content-articles-edit", "content-articles-delete", "content-boxes-edit", "content-boxes-new", "content-editbook", "content-editseparator", "content-editlink", "content-editgallery", "content-manageimgs")), "content-move" => array($_lang['admin.content.move.title'], _loginright_admincontent, "content", array()), "content-titles" => array($_lang['admin.content.titles.title'], _loginright_admincontent, "content", array()), "content-articles" => array($_lang['admin.content.articles.title'], _loginright_adminart, "content", array()), "content-articles-list" => array($_lang['admin.content.articles.list.title'], _loginright_adminart, "content-articles", array()), "content-articles-edit" => array($_lang['admin.content.articles.edit.title'], _loginright_adminart, "content-articles", array(), true), "content-articles-delete" => array($_lang['admin.content.articles.delete.title'], _loginright_adminart, "content-articles", array(), true), "content-confirm" => array($_lang['admin.content.confirm.title'], _loginright_adminconfirm, "content", array()), "content-movearts" => array($_lang['admin.content.movearts.title'], _loginright_admincategory, "content", array()), "content-polls" => array($_lang['admin.content.polls.title'], _loginright_adminpoll, "content", array()), "content-polls-edit" => array($_lang['admin.content.polls.edit.title'], _loginright_adminpoll, "content-polls", array()), "content-boxes" => array($_lang['admin.content.boxes.title'], _loginright_adminbox, "content", array()), "content-boxes-edit" => array($_lang['admin.content.boxes.edit.title'], _loginright_adminbox, "content-boxes", array()), "content-boxes-new" => array($_lang['admin.content.boxes.new.title'], _loginright_adminbox, "content-boxes", array(), true), "content-delete" => array($_lang['admin.content.delete.title'], true, "content", array()), "content-editsection" => array($_lang['admin.content.editsection.title'], _loginright_adminsection, "content", array()), "content-editcategory" => array($_lang['admin.content.editcategory.title'], _loginright_admincategory, "content", array()), "content-editintersection" => array($_lang['admin.content.editintersection.title'], _loginright_adminintersection, "content", array()), "content-editbook" => array($_lang['admin.content.editbook.title'], _loginright_adminbook, "content", array()), "content-editseparator" => array($_lang['admin.content.editseparator.title'], _loginright_adminseparator, "content", array()), "content-editlink" => array($_lang['admin.content.editlink.title'], _loginright_adminlink, "content", array()), "content-editgallery" => array($_lang['admin.content.editgallery.title'], _loginright_admingallery, "content", array()), "content-manageimgs" => array($_lang['admin.content.manageimgs.title'], _loginright_admingallery, "content", array(), true), "users" => array($_lang['admin.menu.users'], _loginright_adminusers or _loginright_admingroups, null, array("users-editgroup", "users-delgroup", "users-edit", "users-delete", "users-list", "users-move")), "users-editgroup" => array($_lang['admin.users.groups.edittitle'], _loginright_admingroups, "users", array()), "users-delgroup" => array($_lang['admin.users.groups.deltitle'], _loginright_admingroups, "users", array()), "users-edit" => array($_lang['admin.users.edit.title'], _loginright_adminusers, "users", array()), "users-delete" => array($_lang['admin.users.deleteuser'], _loginright_adminusers, "users", array()), "users-list" => array($_lang['admin.users.list'], _loginright_adminusers, "users", array()), "users-move" => array($_lang['admin.users.move'], _loginright_adminusers, "users", array()), "fman" => array($_lang['admin.menu.fman'], _loginright_adminfman, null, array()), "settings" => array($_lang['admin.menu.settings'], _loginright_adminsettings, null, array()), "other" => array($_lang['admin.menu.other'], _loginright_adminbackup or _loginright_adminmassemail or _loginright_adminbans, null, array("other-backup", "other-massemail", "other-bans")), "other-backup" => array($_lang['admin.other.backup.title'], _loginright_adminbackup, "other", array()), "other-massemail" => array($_lang['admin.other.massemail.title'], _loginright_adminmassemail, "other", array()), "other-bans" => array($_lang['admin.other.bans.title'], _loginright_adminbans, "other", array()));
            if (isset($modules[$getp][0])) {
                $admintitle = $modules[$getp][0];
            } 
            $menuitems = array("index", "content", "users", "fman", "settings", "other");
            $menu = '<div id="menu"><div id="menu-padding">';
            $counter = 1;
            $menuitems_total = count($menuitems);
            foreach($menuitems as$item) {
                if ($modules[$item][1] == true) {
                    if (isset($getp)) {
                        if ($getp == $item or in_array($getp, $modules[$item][3])) {
                            $class = " class='act'";
                        } else {
                            $class = "";
                        } 
                    } 
                    $menu .= "<a href='index.php?p=" . $item . "'$class>" . $modules[$item][0] . "</a> | ";
                } 
            } 
            $menu = mb_substr($menu, 0, mb_strlen($menu)-3) . '</div></div><hr class="hidden" />';
        } 
        $output .= '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<meta name="generator" content="SunLight CMS ' . _systemversion . '" />
<link href="' . _indexroot . 'admin/style.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="' . _indexroot . 'remote/javascript.php"></script>
<script type="text/javascript" src="' . _indexroot . 'admin/javascript.php"></script>
<title>SunLight CMS - ' . $admintitle . '</title>
</head>

<body>';
        if (_loginindicator and _loginright_administration) {
            $output .= '
<div id="shortcut-icons">
<a href="../" target="_blank" title="' . $_lang['admin.topicon.home'] . '"><img src="images/icons/home.gif" class="micon"  alt="home" /></a>
<a href="./" target="_blank" title="' . $_lang['admin.topicon.newwin'] . '"><img src="images/icons/newwin.gif" class="micon"  alt="new window" /></a>
<a href="http://sunlight-cms.net/feedback/docs.php" target="_blank" title="' . $_lang['admin.topicon.help'] . '"><img src="images/icons/help.gif" class="micon"  alt="help" /></a>
</div>';
        } 
        $output .= '
<div id="shade-top"></div>
<div id="shade-middle">
<div id="container">
<div id="container-padding">
';
        if (_loginindicator and _loginright_administration) {
            $output .= '
<div id="logo"><span>' . $usermenu . '</span></div>
<hr class="hidden" />
' . $menu;
        } 
        $output .= '<div id="content">';
        if (_loginindicator and _loginright_administration != 1) {
            $output .= "<h1>" . $_lang['global.error'] . "</h1>" . _formMessage(3, $_lang['admin.denied']);
        } 
        if (_loginindicator and _loginright_administration) {
            if (array_key_exists($getp, $modules)) {
                if ($modules[$getp][1] == true and($modules[$getp][2] == null or$modules[$modules[$getp][2]][1] == true)) {
                    if ($modules[$getp][2] != null and!isset($modules[$getp][4])) {
                        $output .= "<a href='index.php?p=" . $modules[$getp][2] . "' class='backlink'>&lt; " . $_lang['global.return'] . "</a>";
                    } 
                    if (!isset($modules[$getp][4])) {
                        $output .= "<h1>" . $modules[$getp][0] . "</h1>";
                    } 
                    $file = "require/" . $getp . ".php";
                    if (file_exists($file)) {
                        require($file);
                    } else {
                        $output .= _formMessage(2, $_lang['admin.moduleunavailable']);
                    } 
                } else {
                    $output .= "<h1>" . $_lang['global.error'] . "</h1>" . _formMessage(3, $_lang['global.accessdenied']);
                } 
            } else {
                $output .= "<h1>" . $_lang['global.error404.title'] . "</h1>" . _formMessage(2, $_lang['global.error404']);
            } 
        } else {
            $login = _uniForm("login", array('return' => 'admin', 'returnpath' => null));
            $output .= $login[0];
            $output .= '<a href="../">&lt; ' . $_lang['admin.homelink'] . '</a>';
        } 
        $output .= '
</div>


</div>
</div>
</div>
<div id="shade-bottom"></div>

<hr class="hidden" />
<div id="copyright">' . _condReturn(_loginindicator and _loginright_administration, '<a href="http://sunlight-cms.net/feedback/docs.php?id=' . $getp . '" target="_blank">' . $_lang['admin.content.form.pagehelp'] . '</a> | ') . '<a href="http://sunlight-cms.net/" target="_blank">SunLight CMS</a> by <a href="http://shiranai7.sunlight-cms.net/" target="_blank">ShiraNai7</a></div>

</body>
</html>';
        if (!defined('_tmp_redirect')) {
            echo$output;
        } else {
            header("location: " . _tmp_redirect);
            exit;
        } 
    } 
} 
function _anchorStr($input, $lower = true) {
    $input = str_replace(array("é", "ě", "É", "Ě", "ř", "Ř", "ť", "Ť", "ž", "Ž", "ú", "Ú", "ů", "Ů", "ü", "Ü", "í", "Í", "ó", "Ó", "á", "Á", "š", "Š", "ď", "Ď", "ý", "Ý", "č", "Č", "ň", "Ň", "ä", "Ä", "ĺ", "Ĺ", "ľ", "Ľ", "ŕ", "Ŕ", "ö", "Ö"), array("e", "e", "E", "E", "r", "R", "t", "T", "z", "Z", "u", "U", "u", "U", "u", "U", "i", "I", "o", "O", "a", "A", "s", "S", "d", "D", "y", "Y", "c", "C", "n", "N", "a", "A", "l", "L", "l", "L", "r", "R", "o", "O"), $input);
    $input = str_replace(" ", "-", $input);
    $output = "";
    $len = mb_strlen($input);
    for($x = 0;$x < $len;$x++) {
        $char = mb_substr($input, $x, 1);
        if (in_array($char, array("A", "a", "B", "b", "C", "c", "D", "d", "E", "e", "F", "f", "G", "g", "H", "h", "I", "i", "J", "j", "K", "k", "L", "l", "M", "m", "N", "n", "O", "o", "P", "p", "Q", "q", "R", "r", "S", "s", "T", "t", "U", "u", "V", "v", "W", "w", "X", "x", "Y", "y", "Z", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".", "-"))) {
            $output .= $char;
        } 
    } 
    $output = preg_replace('|--+|', '-', $output);
    $output = preg_replace('|\.\.+|', '.', $output);
    $output = preg_replace('|\.-+|', '.', $output);
    $output = preg_replace('|-\.+|', '-', $output);
    $output = trim($output, "-_.");
    if ($lower == true) {
        $output = mb_strtolower($output);
    } 
    return$output;
} 
function _arrayDefineKeys($array, $keys) {
    foreach($keys as$key => $value) {
        if (!isset($array[$key])) {
            $array[$key] = $value;
        } 
    } 
    return$array;
} 
function _arrayRemoveKey($array, $key_remove, $preserve_keys = false) {
    $output = array();
    foreach($array as$key => $value) {
        if ($key != $key_remove) {
            if (!$preserve_keys) {
                $output[] = $value;
            } else {
                $output[$key] = $value;
            } 
        } 
    } 
    return$output;
} 
function _arrayRemoveValue($array, $value_remove, $preserve_keys = false) {
    $output = array();
    foreach($array as$key => $value) {
        if ($value != $value_remove) {
            if (!$preserve_keys) {
                $output[] = $value;
            } else {
                $output[$key] = $value;
            } 
        } 
    } 
    return$output;
} 
function _arraySplitFromKey($array, $keyfrom) {
    $output = array();
    $counter = 0;
    foreach($array as$key => $value) {
        if ($counter > $keyfrom) {
            if (!isset($output[$keyfrom])) {
                $output[$keyfrom] = null;
            } 
            $output[$keyfrom] .= "," . $value;
        } else {
            $output[] = $value;
        } 
        $counter++;
    } 
    return$output;
} 
function _articleOutput($id) {
    global$_lang;
    $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-articles` WHERE id=" . $id));
    $home1_public = mysql_fetch_array(mysql_query("SELECT public FROM `" . _mysql_prefix . "-root` WHERE id=" . $query['home1']));
    $home1_public = $home1_public['public'];
    if ($query['home2'] != -1) {
        $home2_public = mysql_fetch_array(mysql_query("SELECT public FROM `" . _mysql_prefix . "-root` WHERE id=" . $query['home2']));
        $home2_public = $home2_public['public'];
    } else {
        $home2_public = 1;
    } 
    if ($query['home3'] != -1) {
        $home3_public = mysql_fetch_array(mysql_query("SELECT public FROM `" . _mysql_prefix . "-root` WHERE id=" . $query['home3']));
        $home3_public = $home3_public['public'];
    } else {
        $home3_public = 1;
    } 
    if (_publicAccess($query['public'])and _publicAccess($home1_public)and _publicAccess($home2_public)and _publicAccess($home3_public)) {
        $content = "";
        if ($query['visible'] == 1) {
            $content .= $_lang['article.category'] . ": ";
            for($i = 1;$i <= 3;$i++) {
                if ($query['home' . $i] != -1) {
                    $hometitle = mysql_fetch_array(mysql_query("SELECT title FROM `" . _mysql_prefix . "-root` WHERE id=" . $query['home' . $i]));
                    $content .= "<a href='" . _linkRoot($query['home' . $i]) . "'>" . $hometitle['title'] . "</a>";
                } 
                if ($i != 3 and$query['home' . ($i + 1)] != -1) {
                    $content .= ", ";
                } 
            } 
            $content .= "<div class='hr'><hr /></div>";
        } 
        $title = $query['title'];
        if (_template_autoheadings) {
            $content .= "<h1>" . $title . "</h1>";
        } 
        $content .= "<p class='article-perex'>" . _parseHCM($query['perex']) . "</p>";
        $content .= _parseHCM($query['content']);
        $content .= "
    <a name='ainfo'></a>
    <table class='article-info'>
    <tr valign='top'>
    ";
        $content .= "
      <td>
      <strong>" . $_lang['article.author'] . ":</strong> " . _linkUser($query['author']) . "<br />
      <strong>" . $_lang['article.posted'] . ":</strong> " . _formatTime($query['time']) . "<br />
      <strong>" . $_lang['article.readed'] . ":</strong> " . $query['readed'] . "x
      ";
        if (_loginright_adminart) {
            $content .= "<br /><strong>" . $_lang['article.id'] . ":</strong> " . $id;
        } 
        if ($query['rateon'] == 1) {
            if ($query['ratenum'] != 0) {
                $rate = (round($query['ratesum'] / $query['ratenum'])) . "% (" . $_lang['article.rate.num'] . " " . $query['ratenum'] . "x)";
            } else {
                $rate = $_lang['article.rate.nodata'];
            } 
            $content .= "<br /><strong>" . $_lang['article.rate'] . ":</strong> " . $rate;
        } 
        $rateform = "";
        if ($query['rateon'] == 1 and _loginright_artrate and _iplogCheck(3, $query['id'])) {
            $rateform .= "<strong>" . $_lang['article.rate.do'] . ":</strong>
        <form action='" . _indexroot . "remote/artrate.php' method='post'>
        <input type='hidden' name='id' value='" . $query['id'] . "' />
        <select name='r'>
        ";
            for($x = 0;$x <= 100;$x += 10) {
                if ($x == 50) {
                    $selected = " selected='selected'";
                } else {
                    $selected = "";
                } 
                $rateform .= "<option value='" . $x . "'" . $selected . ">" . $x . "%</option>";
            } 
            $rateform .= "
        </select>&nbsp;
        <input type='submit' value='" . $_lang['global.do'] . "' />
        </form>
        ";
        } 
        if ($query['infobox'] != "") {
            $content .= "<br /><br />" . $rateform;
        } 
        $content .= "</td>";
        $content .= "<td>";
        if ($query['infobox'] == "") {
            $content .= $rateform;
        } else {
            $content .= _parseHCM($query['infobox']);
        } 
        $content .= "</td>";
        $content .= "</tr></table>";
        if ($query['comments'] == 1 and _comments) {
            $content .= _commentsOutput(2, $id);
        } 
        if ($query['confirmed'] == 1 and _iplogCheck(2, $id)) {
            mysql_query("UPDATE `" . _mysql_prefix . "-articles` SET readed=" . ($query['readed'] + 1) . " WHERE id=" . $id);
            _iplogUpdate(2, $id);
        } 
    } else {
        $form = _uniForm("notpublic");
        $content = $form[0];
        $title = $form[1];
    } 
    return array($content, $title);
} 
function _articleOutputPreview($art, $info = true, $perex = true) {
    global$_lang;
    $output = "<h2 class='list-title'><a href='" . _linkArticle($art['id']) . "'>" . $art['title'] . "</a></h2>";
    if ($perex == true) {
        $output .= "<p class='list-perex'>" . $art['perex'] . "</p>";
    } 
    if ($info == true) {
        if ($art['comments'] == 1 and _comments) {
            $info_comments = _template_listinfoseparator . "<span>" . $_lang['article.comments'] . ":</span> " . mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-posts` WHERE home=" . $art['id'] . " AND type=2"), 0);
        } else {
            $info_comments = "";
        } 
        $output .= "
  <div class='list-info'>
  <span>" . $_lang['article.author'] . ":</span> " . _linkUser($art['author'], null, true) . _template_listinfoseparator . "<span>" . $_lang['article.posted'] . ":</span> " . _formatTime($art['time'], null, true) . _template_listinfoseparator . "<span>" . $_lang['article.readed'] . ":</span> " . $art['readed'] . "x" . $info_comments . "</div>\n";
    } 
    return$output;
} 
function _bookOutput($id) {
    global$_lang;
    $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-root` WHERE id=" . $id));
    $title = $query['title'];
    $content = "";
    if (_template_autoheadings) {
        $content .= "<h1>" . $query['title'] . _linkRSS($id, 3) . "</h1>" . _parseHCM($query['content']);
    } else {
        $content .= _linkRSS($id, 4);
        if ($query['content'] != "") {
            $content .= _parseHCM($query['content']);
        } 
    } 
    $content .= _commentsOutput(3, $id, array($query['var2'], $query['var1'] == 1 or _loginindicator));
    return array($content, $title);
} 
function _boolean($input) {
    if ($input == 1) {
        return true;
    } else {
        return false;
    } 
} 
function _booleanStr($input) {
    if ($input == true) {
        return"true";
    } else {
        return"false";
    } 
} 
function _captchaCheck() {
    if (_captcha and!_loginindicator) {
        $cpk = str_replace("O", "0", mb_strtoupper(_slcDecode($_POST['_cpk'])));
        $cp = str_replace("O", "0", mb_strtoupper($_POST['_cp']));
        return$cpk == $cp;
    } else {
        return true;
    } 
} 
function _captchaInit() {
    if (_captcha and!_loginindicator) {
        global$_lang;
        $key = "";
        for($i = 0;$i <= 4;$i++) {
            if (mt_rand(0, 1) > 0.5) {
                $key .= mt_rand(0, 9);
            } else {
                $key .= chr(mt_rand(65, 90));
            } 
        } 
        $key = str_replace("O", "0", $key);
        $key = _slcEncode($key);
        return array("<input type='hidden' name='_cpk' value='" . $key . "' />", array($_lang['captcha.input'], "<input type='text' name='_cp' class='inputc' />&nbsp;<img src='" . _indexroot . "remote/cimage.php?cpk=" . $key . "' alt='img' title='" . $_lang['captcha.help'] . "' class='cimage' />"));
    } else {
        return array("", array("", ""));
    } 
} 
function _categoryOutput($id) {
    global$_lang;
    $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-root` WHERE id=" . $id));
    $artsperpage = $query['var2'];
    switch ($query['var1']) {
        case 1:$artorder = "time DESC";
            break;
        case 2:$artorder = "id DESC";
            break;
        case 3:$artorder = "title";
            break;
        case 4:$artorder = "title DESC";
            break;
    } 
    $content = "";
    if (_template_autoheadings) {
        $content .= "<h1>" . $query['title'] . _linkRSS($id, 4) . "</h1>" . _parseHCM($query['content']) . "<div class='hr'><hr /></div>";
    } else {
        $content .= _linkRSS($id, 4);
        if ($query['content'] != "") {
            $content .= _parseHCM($query['content']) . "<div class='hr'><hr /></div>";
        } 
    } 
    $arts_cond = "(home1=" . $id . " OR home2=" . $id . " OR home3=" . $id . ") AND confirmed=1 AND visible=1 AND time<=" . time() . " ORDER BY " . $artorder;
    $paging = _resultPaging(_indexOutput_url, $artsperpage, "articles", $arts_cond);
    $arts = mysql_query("SELECT id,title,author,perex,time,comments,public,readed FROM `" . _mysql_prefix . "-articles` WHERE " . $arts_cond . " " . $paging[1]);
    if (mysql_num_rows($arts) != 0) {
        $content .= $paging[0];
        while ($art = mysql_fetch_array($arts)) {
            $content .= _articleOutputPreview($art);
        } 
        if (_pagingmode == 2) {
            $content .= '<br />' . $paging[0];
        } 
    } else {
        $content .= $_lang['category.noarts'];
    } 
    $title = $query['title'];
    return array($content, $title);
} 
function _checkboxActivate($input) {
    if ($input == 1) {
        return" checked='checked'";
    } 
} 
function _checkboxLoad($input) {
    if (isset($_POST[$input])) {
        return 1;
    } else {
        return 0;
    } 
} 
function _checkVersion($type, $version) {
    switch ($type) {
        case"database_backup":$compatible_versions = array("7.0.0", "7.0.1", "7.1.0");
            break;
        case"language_file":$compatible_versions = array("7.1.0");
            break;
        case"template":$compatible_versions = array("7.0.0", "7.0.1", "7.1.0");
            break;
    } 
    return in_array($version, $compatible_versions);
} 
function _commentsOutput($type, $home, $vars = null) {
    global$_lang;
    switch ($type) {
        case 1:$subclass = "comments";
            $title = $_lang['posts.comments'];
            $addlink = $_lang['posts.addcomment'];
            $nopostsmessage = $_lang['posts.nocomments'];
            $postsperpage = _commentsperpage;
            $canpost = _loginright_postcomments;
            $replynote = true;
            break;
        case 2:$subclass = "comments";
            $title = $_lang['posts.comments'];
            $addlink = $_lang['posts.addcomment'];
            $nopostsmessage = $_lang['posts.nocomments'];
            $postsperpage = _commentsperpage;
            $canpost = _loginright_postcomments;
            $replynote = true;
            break;
        case 3:$subclass = "book";
            $title = null;
            $addlink = $_lang['posts.addpost'];
            $nopostsmessage = $_lang['posts.noposts'];
            $postsperpage = $vars[0];
            $canpost = $vars[1];
            $replynote = true;
            break;
    } 
    $output = "
  <a name='posts'></a>
  <div class='posts-" . $subclass . "'>
  ";
    if ($title != null) {
        $output .= "<h2>" . $title . _linkRss($home, $type) . "</h2>";
    } 
    $output .= "<div class='posts-form'>";
    if (isset($_GET['addpost'])or isset($_GET['replyto'])) {
        if (isset($_GET['replyto'])) {
            $reply = intval($_GET['replyto']);
            if ($replynote) {
                $output .= "<p>" . $_lang['post.replynote'] . " (<a href='" . _indexOutput_url . "#posts'>" . $_lang['global.cancel'] . "</a>).</p>";
            } 
        } else {
            $reply = -1;
        } 
        if ($canpost) {
            $form = _uniForm("postform", array('posttype' => $type, 'posttarget' => $home, 'xhome' => $reply));
            $output .= $form[0];
        } else {
            $loginform = _uniForm("login", array('return' => -1, 'returnpath' => _indexOutput_url), true);
            $output .= "<p>" . $_lang['posts.loginrequired'] . "</p>" . $loginform[0];
        } 
    } else {
        $output .= "<a href='" . _addGetToLink(_indexOutput_url, "addpost") . "#posts'>" . $addlink . " &gt;</a>";
    } 
    $output .= "</div>";
    if (isset($_GET['r'])) {
        switch ($_GET['r']) {
            case 0:$output .= _formMessage(2, $_lang['posts.failed']);
                break;
            case 1:$output .= _formMessage(1, $_lang['posts.added']);
                break;
            case 2:$output .= _formMessage(2, str_replace("*postsendexpire*", _postsendexpire, $_lang['posts.limit']));
                break;
        } 
    } 
    $output .= "<div class='hr'><hr /></div>";
    $paging = _resultPaging(_indexOutput_url, $postsperpage, "posts", "type=" . $type . " AND xhome=-1 AND home=" . $home, "#posts");
    $output .= $paging[0];
    $query = mysql_query("SELECT * FROM `" . _mysql_prefix . "-posts` WHERE type=" . $type . " AND xhome=-1 AND home=" . $home . " ORDER BY id DESC " . $paging[1]);
    if (mysql_num_rows($query) != 0) {
        while ($item = mysql_fetch_array($query)) {
            if ($item['guest'] == "") {
                $author = _linkUser($item['author'], "post-author");
            } else {
                $author = "<span class='post-author-guest' title='" . $item['ip'] . "'>" . $item['guest'] . "</span>";
            } 
            $actlinks = " <span class='post-actions'>";
            $actlinks .= "<a href='" . _addGetToLink(_indexOutput_url, "replyto=" . $item['id']) . "#posts'>" . $_lang['posts.reply'] . "</a>";
            if (_postAccess($item)) {
                $actlinks .= " <a href='index.php?m=editpost&amp;id=" . $item['id'] . "'>" . $_lang['global.edit'] . "</a>";
            } 
            $actlinks .= "</span>";
            $output .= "<div class='post-head'>" . $author . ", <span class='post-subject'>" . $item['subject'] . "</span> <span class='post-info'>(" . _formatTime($item['time']) . ")</span>" . $actlinks . "</div><p class='post-body'>" . _parsePost($item['text']) . "</p>\n";
            $answers = mysql_query("SELECT * FROM `" . _mysql_prefix . "-posts` WHERE type=" . $type . " AND home=" . $home . " AND xhome=" . $item['id'] . " ORDER BY id");
            while ($answer = mysql_fetch_array($answers)) {
                if ($answer['guest'] == "") {
                    $author = _linkUser($answer['author'], "post-author");
                } else {
                    $author = "<span class='post-author-guest' title='" . $answer['ip'] . "'>" . $answer['guest'] . "</span>";
                } 
                if (_postAccess($item)) {
                    $actlinks = " <span class='post-actions'><a href='index.php?m=editpost&amp;id=" . $answer['id'] . "'>" . $_lang['global.edit'] . "</a></span>";
                } else {
                    $actlinks = "";
                } 
                $output .= "<div class='post-answer'><div class='post-head'>" . $author . " " . $_lang['posts.replied'] . " <span class='post-info'>(" . _formatTime($answer['time']) . ")</span>" . $actlinks . "</div><p class='post-body'>" . _parsePost($answer['text']) . "</p></div>\n";
            } 
        } 
        if (_pagingmode == 2) {
            $output .= "<br />" . $paging[0];
        } 
    } else {
        $output .= "<p>" . $nopostsmessage . "</p>";
    } 
    $output .= "</div>";
    return$output;
} 
function _condReturn($cond, $input, $elseinput = null) {
    if ($cond == true) {
        return$input;
    } else {
        if ($elseinput != null) {
            return$elseinput;
        } 
    } 
} 
function _currentScript($headerformat = false) {
    return basename($_SERVER['PHP_SELF']) . _condReturn($_SERVER['QUERY_STRING'] != "", "?" . _condReturn($headerformat == false, _htmlStr($_SERVER['QUERY_STRING']), $_SERVER['QUERY_STRING']));
} 
function _cutStr($string, $length, $convert_entities = true) {
    if ($convert_entities) {
        $string = _htmlStrUndo($string);
    } 
    if (mb_strlen($string) > $length) {
        $string = mb_substr($string, 0, $length-3) . "...";
    } 
    if ($convert_entities) {
        $string = _htmlStr($string);
    } 
    return$string;
} 
function _deleteUser($id) {
    if ($id != 0) {
        $username = mysql_fetch_array(mysql_query("SELECT username FROM `" . _mysql_prefix . "-users` WHERE id=" . $id));
        mysql_query("DELETE FROM `" . _mysql_prefix . "-users` WHERE id=" . $id);
        mysql_query("UPDATE `" . _mysql_prefix . "-posts` SET guest='" . $username['username'] . "' WHERE author=" . $id);
        mysql_query("UPDATE `" . _mysql_prefix . "-posts` SET author=-1 WHERE author=" . $id);
        mysql_query("UPDATE `" . _mysql_prefix . "-articles` SET author=0 WHERE author=" . $id);
        mysql_query("DELETE FROM `" . _mysql_prefix . "-messages` WHERE receiver=" . $id . " OR sender=" . $id);
    } 
} 
function _evalBox($code) {
    $output = "";
    eval($code);
    return$output;
} 
function _eventList($events, $intro = null) {
    if ($intro != null) {
        if ($intro != "errors") {
            $output = $intro;
        } else {
            global$_lang;
            $output = $_lang['errorlog.intro'];
        } 
    } else {
        $output = "";
    } 
    $output .= "<ul>";
    foreach($events as$item) {
        $output .= "<li>" . $item . "</li>";
    } 
    $output .= "</ul>";
    return$output;
} 
function _formatTime($timestamp) {
    $output = getdate($timestamp);
    if (strlen($output['hours']) == 1) {
        $output['hours'] = "0" . $output['hours'];
    } 
    if (strlen($output['minutes']) == 1) {
        $output['minutes'] = "0" . $output['minutes'];
    } 
    $output = $output['mday'] . "." . $output['mon'] . ". " . $output['year'] . " " . $output['hours'] . ":" . $output['minutes'];
    return$output;
} 
function _formMessage($type, $string) {
    return"<div class='message" . $type . "'>$string</div>";
} 
function _formOutput($name, $action, $cells, $check = null, $submittext = null, $codenexttosubmit = null) {
    global$_lang;
    if ($check != null) {
        $checkcode = _jsCheckForm($name, $check);
    } else {
        $checkcode = "";
    } 
    if ($submittext != null) {
        $submit = $submittext;
    } else {
        $submit = $_lang['global.send'];
    } 
    $output = "
<form action='" . $action . "' method='post' name='" . $name . "'" . $checkcode . ">
<table>";
    foreach($cells as$cell) {
        if ($cell[0] != "") {
            $output .= "
    <tr" . _condReturn(isset($cell[2]), " valign='top'") . ">
    <td class='rpad'><strong>" . $cell[0] . "</strong></td>
    <td>" . $cell[1] . "</td>
    </tr>";
        } 
    } 
    $output .= "
  <tr>
  <td></td>
  <td><input type='submit' value='" . $submit . "' />" . $codenexttosubmit . "</td>
  </tr>

</table>
</form>";
    return$output;
} 
function _galleryOutput($id) {
    global$_lang;
    $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-root` WHERE id=" . $id));
    $content = "";
    if (_template_autoheadings) {
        $content .= "<h1>" . $query['title'] . "</h1>" . _parseHCM($query['content']) . "<div class='hr'><hr /></div>";
    } else {
        if ($query['content'] != "") {
            $content .= _parseHCM($query['content']) . "<div class='hr'><hr /></div>";
        } 
    } 
    $paging = _resultPaging(_indexOutput_url, $query['var2'], "images", "home=" . $id);
    $images = mysql_query("SELECT * FROM `" . _mysql_prefix . "-images` WHERE home=" . $id . " ORDER BY ord " . $paging[1]);
    if (mysql_num_rows($images) != 0) {
        $usetable = $query['var1'] != -1;
        if ($paging[3] > 1) {
            $content .= $paging[0];
        } 
        if ($usetable) {
            $content .= "<table class='gallery'>";
        } else {
            $content .= "<div class='gallery'>";
        } 
        $counter = 0;
        while ($img = mysql_fetch_array($images)) {
            if ($counter == 0 and$usetable) {
                $content .= "<tr>";
            } 
            if ($usetable) {
                $content .= "<td>";
            } 
            $content .= "<a href='" . _condReturn(!_isAbsolutePath($img['prev']), _indexroot) . $img['full'] . "' target='_blank' rel='lightbox[" . $id . "]'" . _condReturn($img['title'] != "", " title='" . $img['title'] . "'") . ">";
            if ($img['prev'] != "*auto*") {
                $content .= "<img src='" . _condReturn(!_isAbsolutePath($img['prev']), _indexroot) . $img['prev'] . "' alt='preview' />";
            } else {
                $content .= "<img src='" . _indexroot . "remote/imgprev.php?id=" . $img['id'] . "' alt='prev' />";
            } 
            $content .= "</a>";
            if ($usetable) {
                $content .= "</td>";
            } 
            $counter++;
            if ($counter == $query['var1']and$usetable) {
                $counter = 0;
                $content .= "</tr>\n";
            } 
        } 
        if ($usetable) {
            $content .= "</table>";
        } else {
            $content .= "</div>";
        } 
        if (_pagingmode == 2 and$paging[3] > 1) {
            $content .= $paging[0];
        } 
    } else {
        $content .= $_lang['gallery.noimages'];
    } 
    $title = $query['title'];
    return array($content, $title);
} 
function _getNewID($table) {
    $newid = mysql_query("SELECT id FROM `" . _mysql_prefix . "-" . $table . "` ORDER BY id DESC LIMIT 1");
    if (mysql_num_rows($newid) == 0) {
        return 1;
    } else {
        $newid = mysql_fetch_array($newid);
        return$newid['id'] + 1;
    } 
} 
function _getPostformControls($form, $area) {
    $output = "";
    if (_bbcode and _template_bbcode_buttons) {
        $bbcode_array = array("b", "i", "img", "code");
        foreach($bbcode_array as$item) {
            $output .= "<a href=\"#\" onclick=\"return _sysaddbbcode('" . $form . "','" . $area . "','" . $item . "');\"><img src=\"" . _indexroot . "/templates/" . _template . "/images/bbcode/" . $item . ".gif\" alt=\"" . $item . "\" /></a> ";
        } 
    } 
    if (_smileys) {
        if (_bbcode) {
            $output .= "&nbsp;&nbsp;";
        } 
        for($x = 1;$x <= 10;$x++) {
            $output .= "<a href=\"#\" onclick=\"return _sysaddsmiley('" . $form . "','" . $area . "'," . $x . ");\"><img src=\"" . _indexroot . "/templates/" . _template . "/images/smileys/" . $x . ".gif\" alt=\"" . $x . "\" /></a> ";
        } 
    } 
    return"<span class='posts-form-buttons'>" . trim($output) . "</span>";
} 
function _htmlStr($input) {
    return str_replace(array("&", "<", ">", "\"", "'"), array("&amp;", "&lt;", "&gt;", "&quot;", "&#39;"), $input);
} 
function _htmlStrUndo($input) {
    return str_replace(array("&lt;", "&gt;", "&quot;", "&#39;", "&amp;"), array("<", ">", "\"", "'", "&"), $input);
} 
function _indexOutput($blokace = false) {
    global $_lang;
    $lang = $GLOBALS["language"]; 
    if (isset($_GET['m'])) {
        switch ($_GET['m']) {
            case"login":define('_indexOutput_url', "index.php?m=login");
                $module = _uniForm("login", array('return' => 'mod', 'returnpath' => null));
                define('_indexOutput_content', $module[0]);
                define('_indexOutput_title', $module[1]);
                break;
            case"login_":
                $sBuffer ="<p>".$lang['download.nonlogin']."</p>";
                $sBuffer .=$lang['download.nonlogin.form'];
                $module = _uniForm("login", array('return' => 'login', 'returnpath' => GetAdr()));
                define('_indexOutput_content', $module[0]);
                define('_indexOutput_title', $lang['download.nonlogin']);
                break;
            case"ulist":if (_ulist and(!_notpublicsite or _loginindicator)) {
                    define('_indexOutput_url', "index.php?m=ulist");
                    require(_indexroot . "require/ulist.php");
                    define('_indexOutput_content', $module);
                    define('_indexOutput_title', $_lang['admin.users.list']);
                } 
                break;
            case"reg":if (_registration and!_loginindicator) {
                    define('_indexOutput_url', "index.php?m=reg");
                    require(_indexroot . "require/reg.php");
                    define('_indexOutput_content', $module);
                    define('_indexOutput_title', $_lang['mod.reg']);
                } 
                break;
            case"profile":if (!_notpublicsite or _loginindicator) {
                    define('_indexOutput_url', "index.php?m=profile");
                    require(_indexroot . "require/profile.php");
                    define('_indexOutput_content', $module);
                    define('_indexOutput_title', $_lang['mod.profile']);
                } 
                break;
            case"settings":if (_loginindicator) {
                    define('_indexOutput_url', "index.php?m=settings");
                    require(_indexroot . "require/settings.php");
                    define('_indexOutput_content', $module);
                    define('_indexOutput_title', $_lang['mod.settings']);
                } 
                break;
            case"editpost":if (_loginindicator) {
                    define('_indexOutput_url', "index.php?m=editpost");
                    require(_indexroot . "require/editpost.php");
                    define('_indexOutput_content', $module);
                    define('_indexOutput_title', $_lang['mod.editpost']);
                } 
                break;
            case"messages":if (_loginindicator and _messages) {
                    define('_indexOutput_url', "index.php?m=messages");
                    require(_indexroot . "require/messages.php");
                    define('_indexOutput_content', $module);
                    define('_indexOutput_title', $_lang['mod.messages']);
                } 
                break;
            case"search":if (_search) {
                    define('_indexOutput_url', "index.php?m=search");
                    require(_indexroot . "require/search.php");
                    define('_indexOutput_content', $module);
                    define('_indexOutput_title', $_lang['mod.search']);
                } 
                break;
        } 
    } else {
        if (isset($_GET['a'])) {
            $a = intval($_GET['a']);
            if (mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-articles` WHERE id=" . $a . " AND (confirmed=1 OR " . _loginright_adminconfirm . "=1 OR " . _loginright_adminallart . "=1) AND (time<=" . time() . " OR author=" . _loginid . " OR " . _loginright_adminconfirm . "=1 OR " . _loginright_adminallart . "=1)"), 0) != 0) {
                define('_indexOutput_url', _linkArticle($a));
                if (!_notpublicsite or _loginindicator) {
                    $article = _articleOutput($a);
                    define('_indexOutput_content', $article[0]);
                    define('_indexOutput_title', $article[1]);
                } else {
                    $form = _uniForm("notpublic", array("notpublicsite" => true));
                    define('_indexOutput_content', $form[0]);
                    define('_indexOutput_title', $form[1]);
                } 
            } 
        } else {
            $continue = true;
            if (isset($_GET['p'])) {
                $pid = intval($_GET['p']);
            } else {
                $query = mysql_query("SELECT id FROM `" . _mysql_prefix . "-root` WHERE intersection=-1 AND type!=4 ORDER BY ord LIMIT 1");
                if (mysql_num_rows($query) != 0) {
                    $query = mysql_fetch_array($query);
                    $pid = $query['id'];
                } else {
                    $continue = false;
                } 
            } 
            if ($continue) {
                $query = mysql_query("SELECT type,public,visible,intersection FROM `" . _mysql_prefix . "-root` WHERE id=" . $pid);
                if (mysql_num_rows($query) != 0) {
                    $query = mysql_fetch_array($query);
                    define('_indexOutput_url', _linkRoot($pid));
                    $backlink = "";
                    if ($query['intersection'] != -1 and$query['visible'] == 1) {
                        $backlink = "<a href='" . _linkRoot($query['intersection']) . "' class='backlink'>&lt; " . $_lang['global.return'] . "</a>";
                    } 
                    if ($query['intersection'] != -1) {
                        $intersection_public = mysql_fetch_array(mysql_query("SELECT public FROM `" . _mysql_prefix . "-root` WHERE id=" . $query['intersection']));
                        $intersection_public = $intersection_public['public'];
                    } else {
                        $intersection_public = 1;
                    } 
                    if (_publicAccess($query['public'])and _publicAccess($intersection_public)and _publicAccess(!_notpublicsite)) {
                        switch ($query['type']) {
                            case 1:$content = _sectionOutput($pid);
                                break;
                            case 2:$content = _categoryOutput($pid);
                                break;
                            case 3:$content = _bookOutput($pid);
                                break;
                            case 5:$content = _galleryOutput($pid);
                                break;
                            case 6:$content = _linkOutput($pid);
                                break;
                            case 7:$content = _intersectionOutput($pid);
                                break;
                        } 
                    } else {
                        $form = _uniForm("notpublic", array("notpublicsite" => _notpublicsite));
                        $content = array($form[0], $form[1]);
                    } 
                    define('_indexOutput_content', $backlink . $content[0]);
                    define('_indexOutput_title', $content[1]);
                } 
            } else {
                define('_indexOutput_content', _condReturn(_template_autoheadings, "<h1>" . $_lang['global.error404.title'] . "</h1>") . _formMessage(2, $_lang['global.nokit']));
                define('_indexOutput_title', $_lang['global.error404.title']);
            } 
        } 
    } 
    if (!defined('_indexOutput_content')) {
        define('_indexOutput_content', _condReturn(_template_autoheadings, "<h1>" . $_lang['global.error404.title'] . "</h1>") . _formMessage(2, $_lang['global.error404']));
        define('_indexOutput_title', $_lang['global.error404.title']);
    } 
    if (!defined('_tmp_redirect')) {
        if (!isset($pid)) {
            $pid = -1;
        } 
        define('_indexOutput_pid', $pid);
        if (!defined('_indexOutput_url')) {
            define('_indexOutput_url', '');
        }
        if ($blokace <> true){ 
            require(_coreroot . "../templates/" . _template . "/index.php");
        }
    } else {
        header("location: " . _tmp_redirect);
        exit;
    } 
} 
function _initSession() {
    @session_start();
    $result = 0;
    $rights_array = array("level", "administration", "adminsettings", "adminusers", "admingroups", "admincontent", "adminsection", "admincategory", "adminbook", "adminseparator", "admingallery", "adminlink", "adminintersection", "adminart", "adminallart", "adminchangeartauthor", "adminpoll", "adminpollall", "adminbox", "adminconfirm", "adminneedconfirm", "adminfman", "adminfmanlimit", "adminfmanplus", "adminhcmphp", "adminbackup", "adminmassemail", "adminbans", "changeusername", "unlimitedpostaccess", "postcomments", "artrate", "pollvote");
    if (isset($_SESSION[_sessionprefix . "user"])and isset($_SESSION[_sessionprefix . "password"])) {
        $id = intval($_SESSION[_sessionprefix . "user"]);
        $pass = $_SESSION[_sessionprefix . "password"];
        $query = mysql_query("SELECT * FROM `" . _mysql_prefix . "-users` WHERE id=" . $id);
        $continue = false;
        if (mysql_num_rows($query) != 0) {
            $query = mysql_fetch_array($query);
            $groupblock = mysql_fetch_array(mysql_query("SELECT blocked FROM `" . _mysql_prefix . "-groups` WHERE id=" . $query['group']));
            if ($query['password'] == $pass and$query['blocked'] == 0 and$groupblock['blocked'] == 0) {
                $continue = true;
            } 
        } 
        if ($continue != true) {
            $_SESSION = array();
            session_destroy();
            if (_administration != 1) {
                header("location: " . _indexroot . "index.php?m=login&r=3");
            } else {
                header("location: " . _indexroot . "admin/index.php?r=3");
            } 
        } 
        if ($continue) {
            $result = 1;
            define('_loginname', $query['username']);
            define('_loginwysiwyg', $query['wysiwyg']);
            define('_loginid', $query['id']);
            define('_loginright_group', $query['group']);
            $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-groups` WHERE id=" . $query['group']));
            if (_loginid == 0) {
                $query['level'] = 10001;
            } 
            foreach($rights_array as$item) {
                define('_loginright_' . $item, $query[$item]);
            } 
            mysql_query("UPDATE `" . _mysql_prefix . "-users` SET activitytime='" . time() . "', ip='" . $_SERVER['REMOTE_ADDR'] . "' WHERE id=" . _loginid);
        } 
    } else {
        define('_loginname', '');
        define('_loginwysiwyg', 0);
        define('_loginid', -1);
        define('_loginright_group', 2);
        $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-groups` WHERE id=2"));
        foreach($rights_array as$item) {
            define('_loginright_' . $item, $query[$item]);
        } 
    } 
    define('_loginindicator', $result);
} 
function _inputDisable($cond) {
    if ($cond != true) {
        return" disabled='disabled'";
    } 
} 
function _intersectionOutput($id) {
    global$_lang;
    $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-root` WHERE id=" . $id));
    $content = "";
    if (_template_autoheadings) {
        $content .= "<h1>" . $query['title'] . "</h1>" . _parseHCM($query['content']) . "<div class='hr'><hr /></div>";
    } else {
        if ($query['content'] != "") {
            $content .= _parseHCM($query['content']) . "<div class='hr'><hr /></div>";
        } 
    } 
    $items = mysql_query("SELECT id,title,type,intersectionperex,var1 FROM `" . _mysql_prefix . "-root` WHERE intersection=" . $id . " AND visible=1 ORDER BY ord");
    if (mysql_num_rows($items) != 0) {
        while ($item = mysql_fetch_array($items)) {
            $content .= "<h2 class='list-title'><a href='" . _linkRoot($item['id']) . "'>" . $item['title'] . "</a></h2>";
            if ($item['intersectionperex'] != "") {
                $content .= "<p class='list-perex'>" . $item['intersectionperex'] . "</p>";
            } 
            if ($query['var1'] == 1) {
                $iteminfo = "";
                switch ($item['type']) {
                    case 1:if ($item['var1'] == 1) {
                            $iteminfo .= "<span>" . $_lang['article.comments'] . ":</span> " . mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-posts` WHERE type=1 AND home=" . $item['id']), 0);
                        } 
                        break;
                    case 2:$iteminfo .= "<span>" . $_lang['global.articlesnum'] . ":</span> " . mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-articles` WHERE (home1=" . $item['id'] . " OR home2=" . $item['id'] . " OR home3=" . $item['id'] . ") AND confirmed=1 AND visible=1 AND time<=" . time()), 0);
                        break;
                    case 3:$lastpost = mysql_query("SELECT author,guest FROM `" . _mysql_prefix . "-posts` WHERE home=" . $item['id'] . " ORDER BY id DESC LIMIT 1");
                        if (mysql_num_rows($lastpost) != 0) {
                            $lastpost = mysql_fetch_array($lastpost);
                            if ($lastpost['author'] != -1) {
                                $lastpost = _linkUser($lastpost['author'], null, true, true);
                            } else {
                                $lastpost = $lastpost['guest'];
                            } 
                        } else {
                            $lastpost = "-";
                        } 
                        $iteminfo .= "<span>" . $_lang['global.postsnum'] . ":</span> " . mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-posts` WHERE type=3 AND home=" . $item['id']), 0) . _template_listinfoseparator . "<span>" . $_lang['global.lastpost'] . ":</span> " . $lastpost;
                        break;
                    case 5:$iteminfo .= "<span>" . $_lang['global.imgsnum'] . ":</span> " . mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-images` WHERE home=" . $item['id']), 0);
                        break;
                } 
                if ($iteminfo != "") {
                    $content .= "<div class='list-info'>" . $iteminfo . "</div>\n";
                } 
            } 
        } 
    } else {
        $content .= $_lang['global.nokit'];
    } 
    $title = $query['title'];
    return array($content, $title);
} 
function _iplogCheck($type, $var = null) {
    $return = true;
    $querybasic = "SELECT * FROM `" . _mysql_prefix . "-iplog` WHERE ip='" . _userip . "' AND type=" . $type;
    switch ($type) {
        case 1:$query = mysql_query($querybasic);
            if (mysql_num_rows($query) != 0) {
                $query = mysql_fetch_array($query);
                if ($query['var'] >= _maxloginattempts) {
                    $return = false;
                } 
            } 
            break;
        case 2:case 3:case 4:$query = mysql_query($querybasic . " AND var=" . $var);
            if (mysql_num_rows($query) != 0) {
                $return = false;
            } 
            break;
        case 5:$query = mysql_query($querybasic);
            if (mysql_num_rows($query) != 0) {
                $return = false;
            } 
            break;
    } 
    return$return;
} 
function _iplogUpdate($type, $var = null) {
    $querybasic = "SELECT * FROM `" . _mysql_prefix . "-iplog` WHERE ip='" . _userip . "' AND type=" . $type;
    $newid = _getNewID("iplog");
    switch ($type) {
        case 1:$query = mysql_query($querybasic);
            if (mysql_num_rows($query) != 0) {
                $query = mysql_fetch_array($query);
                mysql_query("UPDATE `" . _mysql_prefix . "-iplog` SET var=" . ($query['var'] + 1) . " WHERE id=" . $query['id']);
            } else {
                mysql_query("INSERT INTO `" . _mysql_prefix . "-iplog` (id,ip,type,time,var) VALUES (" . $newid . ",'" . _userip . "',1," . time() . ",1)");
            } 
            break;
        case 2:mysql_query("INSERT INTO `" . _mysql_prefix . "-iplog` (id,ip,type,time,var) VALUES (" . $newid . ",'" . _userip . "',2," . time() . "," . $var . ")");
            break;
        case 3:mysql_query("INSERT INTO `" . _mysql_prefix . "-iplog` (id,ip,type,time,var) VALUES (" . $newid . ",'" . _userip . "',3," . time() . "," . $var . ")");
            break;
        case 4:mysql_query("INSERT INTO `" . _mysql_prefix . "-iplog` (id,ip,type,time,var) VALUES (" . $newid . ",'" . _userip . "',4," . time() . "," . $var . ")");
            break;
        case 5:mysql_query("INSERT INTO `" . _mysql_prefix . "-iplog` (id,ip,type,time,var) VALUES (" . $newid . ",'" . _userip . "',5," . time() . ",0)");
            break;
    } 
} 
function _isAbsolutePath($path) {
    $path = parse_url($path);
    return isset($path['scheme']);
} 
function _jsCheckForm($form, $inputs) {
    global$_lang;
    $output = " onsubmit=\"if(";
    $count = count($inputs);
    for($x = 1;$x <= $count;$x++) {
        $output .= $form . "." . $inputs[$x-1] . ".value==''";
        if ($x != $count) {
            $output .= " || ";
        } 
    } 
    $output .= "){_sysalert(1); return false;}\"";
    return$output;
} 
function _jsLimitLength($maxlength, $form, $name) {
    return"
<script type='text/javascript'>
//<![CDATA[
document.onkeyup=proces;
document.onmouseup=proces;
document.onmousedown=proces;

function proces(){
value=document.$form.$name.value;
len=$maxlength-value.length;
  if(len<0){
  st=document.$form.$name.scrollTop;
  document.$form.$name.value=document.$form.$name.value.substring(0,$maxlength);
  document.$form.$name.scrollTop=st;
  _sysalert(2);
  }
}

//]]>
</script>
";
} 
function _levelCheck($targetuserid) {
    $group = mysql_fetch_array(mysql_query("SELECT `group`,id FROM `" . _mysql_prefix . "-users` WHERE id=" . $targetuserid));
    $level = mysql_fetch_array(mysql_query("SELECT level FROM `" . _mysql_prefix . "-groups` WHERE id=" . $group['group']));
    if (_loginright_level > $level['level']or(_loginright_level == $level['level']and$group['id'] == _loginid)) {
        return true;
    } else {
        return false;
    } 
} 
function _linkArticle($id) {
    if (_modrewrite != 1) {
        return"index.php?a=" . $id;
    } else {
        $anchor = mysql_fetch_array(mysql_query("SELECT title FROM `" . _mysql_prefix . "-articles` WHERE id=" . $id));
        return _anchorStr($anchor['title']) . ".a" . $id . _linksuffix;
    } 
} 
function _linkOutput($id) {
    global$_lang;
    $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-root` WHERE id=" . $id));
    $title = $query['title'];
    $content = "<a href='" . $query['content'] . "'>" . $title . "</a>";
    define('_tmp_redirect', $query['content']);
    return array($content, $title);
} 
function _linkRoot($id) {
    if (_modrewrite != 1) {
        return"index.php?p=" . $id;
    } else {
        $anchor = mysql_fetch_array(mysql_query("SELECT title FROM `" . _mysql_prefix . "-root` WHERE id=" . $id));
        return _anchorStr($anchor['title']) . ".p" . $id . _linksuffix;
    } 
} 
function _linkRSS($id, $type, $space = true) {
    global$_lang;
    if ($space) {
        $space = " ";
    } else {
        $space = "";
    } 
    if (_rss) {
        return$space . "<a href='" . _indexroot . "remote/rss.php?tp=" . $type . "&amp;id=" . $id . "' target='_blank' title='" . $_lang['rss.linktitle'] . "'><img src='" . _indexroot . "templates/" . _template . "/images/icons/rss.gif' alt='rss' class='icon' /></a>";
    } 
} 
function _linkUser($id, $class = null, $noicon = false, $onlyname = false, $namelengthlimit = false) {
    if ($class != null) {
        $class = " class='" . $class . "'";
    } 
    $userdata = mysql_fetch_array(mysql_query("SELECT username,`group` FROM `" . _mysql_prefix . "-users` WHERE id=" . $id));
    if ($onlyname == false) {
        $groupdata = mysql_fetch_array(mysql_query("SELECT icon FROM `" . _mysql_prefix . "-groups` WHERE id=" . $userdata['group']));
        if ($noicon == false) {
            $icon = _condReturn($groupdata['icon'] != "", "<img src='" . _indexroot . "usericons/" . $groupdata['icon'] . "' alt='icon' class='icon' /> ");
        } else {
            $icon = "";
        } 
        if ($namelengthlimit != false) {
            $username_anchor = _cutStr($userdata['username'], $namelengthlimit, false);
        } else {
            $username_anchor = $userdata['username'];
        } 
        $link = "<a href='" . _indexroot . "index.php?m=profile&amp;id=" . $userdata['username'] . "'" . $class . ">" . $username_anchor . "</a>";
    } else {
        $icon = "";
        $link = $userdata['username'];
    } 
    return$icon . $link;
} 
function _mailto($email) {
    $email = str_replace("@", _atreplace, $email);
    return"<a href='#' onclick='return _sysmai_lto(this);'>" . $email . "</a>";
} 
function _mysqlConnect($server, $user, $password, $database) {
    $con = @mysql_connect($server, $user, $password);
    $db = @mysql_select_db($database);
    if (!$con or!$db) {
        _systemFailure("Připojení k databázi se nezdařilo. Důvodem je pravděpodobně výpadek serveru nebo chybné přístupové údaje.<hr />\n<pre>" . mysql_error() . "</pre>", "Chyba");
    } else {
        mysql_query("SET NAMES `utf8`");
        return$con;
    } 
} 
function _parseHCM($input) {
    global$_lang;
    $output = "";
    $tags = mb_substr_count($input, "[hcm]");
    if ($tags != 0) {
        for($x = 1;$x <= $tags;$x++) {
            $starttag = mb_strpos($input, "[hcm]");
            $output .= mb_substr($input, 0, $starttag);
            $input = mb_substr($input, $starttag + 5, mb_strlen($input) - $starttag + 5);
            $endtag = mb_strpos($input, "[/hcm]");
            if ($endtag) {
                $param = mb_substr($input, 0, $endtag);
                $x += mb_substr_count($param, "[hcm]");
                $paramarray = @explode(",", $param);
                $input = mb_substr($input, $endtag + 6);
                $mresult = "";
                if (count($paramarray) >= 1) {
                    switch (mb_strtolower($paramarray[0])) {
                        case"menu":if (isset($paramarray[1])and isset($paramarray[2])) {
                                $start = intval($paramarray[1]);
                                $length = intval($paramarray[2]);
                            } else {
                                $start = null;
                                $length = null;
                            } 
                            $mresult = _templateMenu($start, $length);
                            break;
                        case"usermenu":$mresult = _templateUserMenu(false);
                            break;
                        case"player":if (count($paramarray) >= 2) {
                                $extension = pathinfo($paramarray[1]);
                                if (isset($extension['extension'])) {
                                    $extension = $extension['extension'];
                                } 
                                if ($extension == "mp3") {
                                    $defheight = "20";
                                } else {
                                    $defheight = "240";
                                } 
                                $defwidth = "320";
                                $file = _htmlStr($paramarray[1]);
                                if (!_isAbsolutePath($file)) {
                                    $file = _url . "/" . $file;
                                } 
                                if (!isset($paramarray[2])) {
                                    $width = $defwidth;
                                } else {
                                    $width = intval($paramarray[2]);
                                } 
                                if (!isset($paramarray[3])) {
                                    $height = $defheight;
                                } else {
                                    $height = intval($paramarray[3]);
                                } 
                                if (!isset($paramarray[4])) {
                                    $autostart = "false";
                                } else {
                                    $autostart = _booleanStr(_boolean($paramarray[4]));
                                } 
                                $mresult = "
            <!--[if !IE]> -->
            <object type='application/x-shockwave-flash' data='" . _indexroot . "remote/hcm/player.swf' width='" . $width . "' height='" . $height . "'>
            <!-- <![endif]-->

            <!--[if IE]>
            <object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0' width='$width' height='$height'>
            <param name='movie' value='" . _indexroot . "remote/hcm/player.swf' />
            <!--><!---->
            <param name='loop' value='true' />
            <param name='menu' value='false' />
            <param name='flashvars' value='file=" . $file . "&amp;height=" . $height . "&amp;width=" . $width . "&amp;autostart=" . $autostart . "' />

            " . $_lang['hcm.player.alt'] . "
            </object>
            <!-- <![endif]-->
            ";
                            } 
                            break;
                        case"notpublic":if (count($paramarray) >= 2) {
                                if (_loginindicator) {
                                    $mresult = $paramarray[1];
                                } else {
                                    if (isset($paramarray[2])) {
                                        $mresult = $paramarray[2];
                                    } 
                                } 
                            } 
                            break;
                        case"levelcontent":if (count($paramarray) >= 3) {
                                if (_loginright_level >= intval($paramarray[1])) {
                                    $mresult = $paramarray[2];
                                } else {
                                    if (isset($paramarray[3])) {
                                        $mresult = $paramarray[3];
                                    } 
                                } 
                            } 
                            break;
                        case"filelist":if (isset($paramarray[1])) {
                                $rdir = _indexroot . $paramarray[1];
                                if (mb_substr($rdir, -1, 1) != "/") {
                                    $rdir .= "/";
                                } 
                                if (file_exists($rdir)and is_dir($rdir)) {
                                    $handle = @opendir($rdir);
                                    while ($item = @readdir($handle)) {
                                        if (is_dir($rdir . $item)or$item == "."or$item == "..") {
                                            continue;
                                        } 
                                        $items[] = $item;
                                    } 
                                    natsort($items);
                                    $mresult = "<ul>";
                                    foreach($items as$item) {
                                        $mresult .= "<li><a href='" . $rdir . $item . "' target='_blank'>" . $item . "</a></li>\n";
                                    } 
                                    $mresult .= "</ul>";
                                    @closedir($handle);
                                } 
                            } 
                            break;
                        case"countusers":if (isset($paramarray[1])) {
                                $cond = " WHERE `group`=" . intval($paramarray[1]);
                            } else {
                                $cond = "";
                            } 
                            $mresult = mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-users`" . $cond), 0);
                            break;
                        case"users":if (count($paramarray) >= 2) {
                                $rtype = $paramarray[1];
                                if (isset($paramarray[2])) {
                                    $rlimit = intval($paramarray[2]);
                                } else {
                                    $rlimit = 5;
                                } 
                                $rcond = "";
                                switch ($rtype) {
                                    case 1:$rorder = "id DESC";
                                        break;
                                    case 2:$rorder = "activitytime DESC";
                                        $rcond = " WHERE " . time() . "-activitytime<1800";
                                        break;
                                    case 3:$rorder = "(SELECT COUNT(*) FROM `" . _mysql_prefix . "-posts` WHERE author=`sunlight-users`.id) DESC";
                                        break;
                                } 
                                $mresult = "<ul>";
                                $query = mysql_query("SELECT id FROM `" . _mysql_prefix . "-users`" . $rcond . " ORDER BY " . $rorder . " LIMIT " . $rlimit);
                                while ($item = mysql_fetch_array($query)) {
                                    $skip = false;
                                    switch ($rtype) {
                                        case 3:$rvar = mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-posts` WHERE author=" . $item['id']), 0);
                                            if ($rvar == 0) {
                                                $skip = true;
                                            } else {
                                                $rext = " (" . $rvar . ")";
                                            } 
                                            break;
                                        default:$rext = "";
                                            break;
                                    } 
                                    if (!$skip) {
                                        $mresult .= "<li>" . _linkUser($item['id']) . $rext . "</li>\n";
                                    } 
                                } 
                                $mresult .= "</ul>";
                            } 
                            break;
                        case"countart":if (isset($paramarray[1])) {
                                $cond = " AND (home1=" . intval($paramarray[1]) . " OR home2=" . intval($paramarray[1]) . " OR home3=" . intval($paramarray[1]) . ")";
                            } else {
                                $cond = "";
                            } 
                            $mresult = mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-articles` WHERE confirmed=1 AND visible=1 AND time<=" . time() . $cond), 0);
                            break;
                        case"randomfile":if (count($paramarray) >= 3 and($paramarray[2] == 1 or$paramarray[2] == 2)) {
                                $rdir = _indexroot . $paramarray[1];
                                $rdir_noroot = $paramarray[1];
                                if (mb_substr($rdir, -1, 1) != "/") {
                                    $rdir .= "/";
                                } 
                                if (mb_substr($rdir_noroot, -1, 1) != "/") {
                                    $rdir_noroot .= "/";
                                } 
                                $rtype = $paramarray[2];
                                if (isset($paramarray[3])) {
                                    $rnumber = intval($paramarray[3]);
                                } else {
                                    $rnumber = 1;
                                } 
                                if (file_exists($rdir)and is_dir($rdir)) {
                                    $handle = @opendir($rdir);
                                    switch ($rtype) {
                                        case 1:$allowed_extensions = array("txt", "htm", "html");
                                            break;
                                        case 2:$allowed_extensions = array("gif", "jpg", "jpeg", "png");
                                            if (isset($paramarray[4])) {
                                                $rheight = intval($paramarray[4]);
                                            } else {
                                                $rheight = 96;
                                            } 
                                            break;
                                    } while ($item = @readdir($handle)) {
                                        $ext = pathinfo($item);
                                        if (isset($ext['extension'])) {
                                            $ext = mb_strtolower($ext['extension']);
                                        } else {
                                            $ext = "";
                                        } 
                                        if (is_dir($item)or$item == "."or$item == ".."or!in_array($ext, $allowed_extensions)) {
                                            continue;
                                        } 
                                        $items[] = $item;
                                    } 
                                    if ($rnumber > count($items)) {
                                        $rnumber = count($items);
                                    } 
                                    $randitems = array_rand($items, $rnumber);
                                    if (!is_array($randitems)) {
                                        $randitems = array($randitems);
                                    } 
                                    foreach($randitems as$item) {
                                        $item = $items[$item];
                                        switch ($rtype) {
                                            case 1:$mresult .= @file_get_contents(_indexroot . $rdir . $item);
                                                break;
                                            case 2:$mresult .= "<a href='" . $rdir . $item . "' target='_blank' rel='lightbox[hcm" . $x . "]'><img src='" . _indexroot . "remote/imgprev.php?id=" . urlencode(_slcEncode($rdir_noroot . $item)) . "&amp;c&amp;h=" . $rheight . "' alt='prev' /></a>\n";
                                                break;
                                        } 
                                    } 
                                    @closedir($handle);
                                } 
                            } 
                            break;
                        case"gallery":if (count($paramarray) >= 2) {
                                $rdir = _indexroot . $paramarray[1];
                                $rdir_noroot = $paramarray[1];
                                if (mb_substr($rdir, -1, 1) != "/") {
                                    $rdir .= "/";
                                } 
                                if (mb_substr($rdir_noroot, -1, 1) != "/") {
                                    $rdir_noroot .= "/";
                                } 
                                if (isset($paramarray[2])) {
                                    $rheight = intval($paramarray[2]);
                                } else {
                                    $rheight = 96;
                                } 
                                $allowed_extensions = array("gif", "jpg", "jpeg", "png");
                                if (file_exists($rdir)and is_dir($rdir)) {
                                    $handle = @opendir($rdir);
                                    $items = array();
                                    while ($item = @readdir($handle)) {
                                        $ext = pathinfo($item);
                                        if (isset($ext['extension'])) {
                                            $ext = mb_strtolower($ext['extension']);
                                        } else {
                                            $ext = "";
                                        } 
                                        if (is_dir($item)or$item == "."or$item == ".."or!in_array($ext, $allowed_extensions)) {
                                            continue;
                                        } 
                                        $items[] = $item;
                                    } 
                                    natsort($items);
                                    $uid = 1;
                                    foreach($items as$item) {
                                        $mresult .= "<a href='" . $rdir . $item . "' target='_blank' rel='lightbox[hcm" . $x . "]'><img src='" . _indexroot . "remote/imgprev.php?id=" . urlencode(_slcEncode($rdir_noroot . $item)) . "&amp;c&amp;h=" . $rheight . "' alt='prev' /></a>\n";
                                        $uid++;
                                    } 
                                    @closedir($handle);
                                } 
                            } 
                            break;
                        case"gallery2":if (count($paramarray) >= 2) {
                                $rdir = _indexroot . $paramarray[1];
                                $rdir_noroot = $paramarray[1];
                                if (mb_substr($rdir, -1, 1) != "/") {
                                    $rdir .= "/";
                                } 
                                if (isset($paramarray[2])) {
                                    $rheight = intval($paramarray[2]);
                                } else {
                                    $rheight = 96;
                                } 
                                $allowed_extensions = array("gif", "jpg", "jpeg", "png");
                                if (file_exists($rdir)and is_dir($rdir)and file_exists($rdir . "prev/")and is_dir($rdir . "prev/")and file_exists($rdir . "full/")and is_dir($rdir . "full/")) {
                                    $handle = @opendir($rdir . "prev/");
                                    $items = array();
                                    while ($item = @readdir($handle)) {
                                        $ext = pathinfo($item);
                                        if (isset($ext['extension'])) {
                                            $ext = mb_strtolower($ext['extension']);
                                        } else {
                                            $ext = "";
                                        } 
                                        if (is_dir($item)or$item == "."or$item == ".."or!in_array($ext, $allowed_extensions)or!file_exists($rdir . "full/" . $item)) {
                                            continue;
                                        } 
                                        $items[] = $item;
                                    } 
                                    natsort($items);
                                    $uid = 1;
                                    foreach($items as$item) {
                                        $mresult .= "<a href='" . $rdir . "full/" . $item . "' target='_blank' rel='lightbox[hcm" . $x . "]'><img src='" . $rdir . "prev/" . $item . "' alt='prev' /></a>\n";
                                        $uid++;
                                    } 
                                    @closedir($handle);
                                } 
                            } 
                            break;
                        case"articles":if (count($paramarray) >= 3) {
                                $paramarray = _arrayDefineKeys($paramarray, array(3 => 1, 4 => 1, 5 => null));
                                $rtype = intval($paramarray[1]);
                                if ($rtype < 1 or$rtype > 7) {
                                    $rtype = 1;
                                } 
                                $rlimit = intval($paramarray[2]);
                                if ($rlimit < 1) {
                                    $rlimit = 1;
                                } 
                                $rperex = _boolean($paramarray[3]);
                                $rinfo = _boolean($paramarray[4]);
                                if ($paramarray[5] != null) {
                                    $rcats = @_arrayRemoveValue(@explode("-", $paramarray[5]), null);
                                    $rcats_code = "(";
                                    $rcats_count = count($rcats);
                                    $counter = 1;
                                    foreach($rcats as$rcat) {
                                        $rcats_code .= "(home1=" . $rcat . " OR home2=" . $rcat . " OR home3=" . $rcat . ")";
                                        if ($counter != $rcats_count) {
                                            $rcats_code .= " OR ";
                                        } 
                                        $counter++;
                                    } 
                                    $rcats_code .= ")";
                                    $rcats = $rcats_code;
                                } else {
                                    $rcats = "";
                                } 
                                switch ($rtype) {
                                    case 1:$rorder = "time DESC";
                                        $rcond = "";
                                        break;
                                    case 2:$rorder = "readed DESC";
                                        $rcond = "readed!=0";
                                        break;
                                    case 3:$rorder = "ratesum/ratenum DESC";
                                        $rcond = "ratenum!=0";
                                        break;
                                    case 4:$rorder = "ratenum DESC";
                                        $rcond = "ratenum!=0";
                                        break;
                                    case 5:$rorder = "RAND()";
                                        $rcond = "";
                                        break;
                                    case 6:$rorder = "(SELECT time FROM `" . _mysql_prefix . "-iplog` WHERE type=2 AND var=`" . _mysql_prefix . "-articles`.id AND `" . _mysql_prefix . "-articles`.visible=1 AND `" . _mysql_prefix . "-articles`.time<=" . time() . " AND `" . _mysql_prefix . "-articles`.confirmed=1 ORDER BY id DESC LIMIT 1) DESC";
                                        $rcond = "readed!=0";
                                        break;
                                    case 7:$rorder = "(SELECT time FROM `" . _mysql_prefix . "-iplog` WHERE type=3 AND var=`" . _mysql_prefix . "-articles`.id AND `" . _mysql_prefix . "-articles`.visible=1 AND `" . _mysql_prefix . "-articles`.time<=" . time() . " AND `" . _mysql_prefix . "-articles`.confirmed=1 ORDER BY id DESC LIMIT 1) DESC";
                                        $rcond = "ratenum!=0";
                                        break;
                                } 
                                $rcond = " WHERE visible=1 AND time<=" . time() . " AND confirmed=1 " . _condReturn($rcond != "", " AND " . $rcond);
                                if ($rcats != "") {
                                    $rcond .= " AND " . $rcats;
                                } 
                                $query = mysql_query("SELECT id,title,perex,author,time,readed,comments FROM `" . _mysql_prefix . "-articles`" . $rcond . " ORDER BY " . $rorder . " LIMIT " . $rlimit);
                                while ($item = mysql_fetch_array($query)) {
                                    $mresult .= _articleOutputPreview($item, $rinfo, $rperex);
                                } 
                            } 
                            break;
                        case"mailform":if (isset($paramarray[1])and _validateEmail(trim($paramarray[1]))) {
                                $paramarray = _arrayDefineKeys($paramarray, array(2 => 0, 3 => ''));
                                $remail = _slcEncode(trim($paramarray[1]));
                                if (_boolean($paramarray[2])) {
                                    $rfile = array($_lang['hcm.mailform.att'], "<input type='file' name='att' />");
                                    $att = true;
                                } else {
                                    $rfile = array('');
                                    $att = false;
                                } 
                                if ($paramarray[3] != "") {
                                    $rsubject = " value='" . _htmlStr($paramarray[3]) . "'";
                                } else {
                                    $rsubject = "";
                                } 
                                $rcaptcha = _captchaInit();
                                if (isset($_GET['mr'])) {
                                    switch ($_GET['mr']) {
                                        case 1:$mresult = _formMessage(1, $_lang['hcm.mailform.msg.done']);
                                            break;
                                        case 2:$mresult = _formMessage(2, $_lang['hcm.mailform.msg.failure']);
                                            break;
                                        case 3:$mresult = _formMessage(3, $_lang['hcm.mailform.msg.failure2']);
                                            break;
                                    } 
                                } 
                                $mresult .= "<a name='mform_" . $x . "'></a>" . _formOutput("mform" . $x, _indexroot . "remote/hcm/mform.php?_return=" . urlencode(_indexOutput_url) . _condReturn($att, "' enctype='multipart/form-data"), array(array($_lang['hcm.mailform.sender'], "<input type='text' class='inputsmall' name='sender' value='&#64;' /><input type='hidden' name='fid' value='" . $x . "' /><input type='hidden' name='rec' value='" . $remail . "' />" . $rcaptcha[0]), array($_lang['posts.subject'], "<input type='text' class='inputsmall' name='subject'" . $rsubject . " />"), $rcaptcha[1], array($_lang['hcm.mailform.text'], "<textarea class='areasmall' name='text' rows='5' cols='33'></textarea>", true), $rfile), array("text", "sender"), $_lang['hcm.mailform.send']);
                            } 
                            break;
                        case"php":if (isset($paramarray[1])) {
                                $paramarray = _arraySplitFromKey($paramarray, 1);
                                $mresult = _evalBox($paramarray[1]);
                            } 
                            break;
 /********************************************************************/
                        case"download":if (isset($paramarray[2])) {
                            //stahnuti pozadovaneho souboru
                            $sNazevSouboru = Str_Val($paramarray[1]); 
                            $sZobrazovaneJmeno = Str_Val($paramarray[2]);  
                            if (empty($paramarray[3])){$sFormat = "hide_table";}
                            else {$sFormat = Str_Val($paramarray[3]);}   
                            if (isset($paramarray[4])){//pokud existuje jina tabulka
                                $output.=Pocitadlo_Download($sNazevSouboru, $sZobrazovaneJmeno,$sFormat,Str_Val($paramarray[4]));
                            }
                            else{
                                $output.=Pocitadlo_Download($sNazevSouboru, $sZobrazovaneJmeno,$sFormat);
                            }
                        }
                        break;                           
                        case"download_edit":if (isset($paramarray[1])) {
                            //funkce pro administraci stahovani souboru
                            //prvni parametr urcuje level od kdy je vydet administrace pocitadel
                            //druhy parametr urcuje level od kdyz je mozno manipulovat s pocitadly, hlavni admin muze cokoliv 
                            $nBuffer = intval($paramarray[1]); 
                            $nBuffer2 = intval($paramarray[2]);               
                            if (_loginright_level >= $nBuffer){
                                if (empty($paramarray[2])){
                                    $nBuffer2 = $nBuffer + 1;
                                }  
                                $output.=administrace_pocitadel($nBuffer2);
                            } else {//chyba neprihlasen
                                $output .="Je nám líto ale pro tuto funkci je potřeba se přihlásit...";
                            }
                        } 
                        break;
                        case"download_show":if (isset($paramarray[1])) {
                            //funkce pro zobrazeni vsech stahovatelnych souboru
                        } 
                        break;
                        case"anketa":if (isset($paramarray[1])) {
                            //funkce pro administraci ankety
                        } 
                        break;
                        case"anketa_edit":if (isset($paramarray[1])) {
                            //funkce pro zobrazeni ankety
                        } 
                        break;
                        case"anketa_all_show":if (isset($paramarray[1])) {
                            //funkce pro zobrazeni vsech anket
                        } 
                        break;
 //****************************************************************************
                        case"recentposts":if (isset($paramarray[1])and$paramarray[1] >= 1) {
                                $rlimit = intval($paramarray[1]);
                            } else {
                                $rlimit = 10;
                            } 
                            if (isset($paramarray[2])) {
                                $rroots = @_arrayRemoveValue(@explode("-", $paramarray[2]), null);
                                $rroots_code = " WHERE (";
                                $rroots_count = count($rroots);
                                $counter = 1;
                                foreach($rroots as$rroot) {
                                    $rroots_code .= "home=" . $rroot;
                                    if ($counter != $rroots_count) {
                                        $rroots_code .= " OR ";
                                    } 
                                    $counter++;
                                } 
                                $rroots_code .= ") AND (type=1 OR type=3)";
                                $rroots = $rroots_code;
                            } else {
                                $rroots = "";
                            } 
                            $query = mysql_query("SELECT id,type,home,author,guest,time,text FROM `" . _mysql_prefix . "-posts`" . $rroots . " ORDER BY id DESC LIMIT " . $rlimit);
                            while ($item = mysql_fetch_array($query)) {
                                switch ($item['type']) {
                                    case 1:case 3:$homelink = _linkRoot($item['home']);
                                        $hometitle = mysql_fetch_array(mysql_query("SELECT title FROM `" . _mysql_prefix . "-root` WHERE id=" . $item['home']));
                                        break;
                                    case 2:$homelink = _linkArticle($item['home']);
                                        $hometitle = mysql_fetch_array(mysql_query("SELECT title FROM `" . _mysql_prefix . "-articles` WHERE id=" . $item['home']));
                                        break;
                                } 
                                if ($item['author'] != -1) {
                                    $authorname = _linkUser($item['author'], null, true, true);
                                } else {
                                    $authorname = $item['guest'];
                                } 
                                $hometitle = $hometitle['title'];
                                $mresult .= "
          <h2 class='list-title'><a href='" . $homelink . "'>" . $hometitle . "</a></h2>
          <p class='list-perex'>" . _cutStr(strip_tags(_parsePost($item['text'])), 256) . "</p>
          <div class='list-info'>
          <span>" . $_lang['global.postauthor'] . ":</span> " . $authorname . _template_listinfoseparator . "
          <span>" . $_lang['global.posttime'] . ":</span> " . _formatTime($item['time']) . "
          </div>\n
          ";
                            } 
                            break;
                        case"poll":if (isset($paramarray[1])) {
                                $rid = intval($paramarray[1]);
                                if (isset($paramarray[2])) {
                                    $rwidth = intval($paramarray[2]);
                                } else {
                                    $rwidth = 125;
                                } 
                                if ($rwidth < 100) {
                                    $rwidth = 100;
                                } 
                                $vpolldata = mysql_query("SELECT * FROM `" . _mysql_prefix . "-polls` WHERE id=" . $rid);
                                if (mysql_num_rows($vpolldata) != 0) {
                                    $vpolldata = mysql_fetch_array($vpolldata);
                                    $rcontinue = true;
                                } else {
                                    $rcontinue = false;
                                } 
                                if ($rcontinue) {
                                    $ranswers = explode("#", $vpolldata['answers']);
                                    $rvotes = explode("-", $vpolldata['votes']);
                                    $rvotes_sum = array_sum($rvotes);
                                    if (_loginright_pollvote == 1 and$vpolldata['locked'] != 1 and _iplogCheck(4, $rid)) {
                                        $rallowvote = true;
                                    } else {
                                        $rallowvote = false;
                                    } 
                                    if ($rallowvote) {
                                        $ranswers_code = "<form action='" . _indexroot . "remote/hcm/pvote.php?_return=" . urlencode(_indexOutput_url) . "#mpoll_" . $x . "' method='post'>\n<input type='hidden' name='pid' value='" . $vpolldata['id'] . "' />";
                                    } else {
                                        $ranswers_code = "";
                                    } 
                                    $ranswer_id = 0;
                                    foreach($ranswers as$item) {
                                        if ($rvotes_sum != 0 and$rvotes[$ranswer_id] != 0) {
                                            $rpercent = $rvotes[$ranswer_id] / $rvotes_sum;
                                            $rbarwidth = $rpercent * ($rwidth - _template_votebarwidthreduction);
                                        } else {
                                            $rpercent = 0;
                                            $rbarwidth = 1;
                                        } 
                                        if ($rallowvote) {
                                            $item = "<label><input type='radio' name='option' value='" . $ranswer_id . "' /> " . $item . " [" . round($rpercent * 100) . "%]</label>";
                                        } else {
                                            $item .= " [" . round($rpercent * 100) . "%]";
                                        } 
                                        $ranswers_code .= "<div class='poll-answer'>" . $item . "<div style='width:" . $rbarwidth . "px;'></div></div>\n";
                                        $ranswer_id++;
                                    } 
                                    $ranswers_code .= "<div class='poll-answer'>";
                                    if ($rallowvote) {
                                        $ranswers_code .= "<input type='submit' value='" . $_lang['hcm.poll.vote'] . "' />&nbsp;";
                                    } 
                                    $ranswers_code .= $_lang['hcm.poll.votes'] . ": " . $rvotes_sum . "</div>";
                                    if ($rallowvote) {
                                        $ranswers_code .= "</form>\n";
                                    } 
                                    $mresult = "
            <a name='mpoll_" . $x . "'></a>
            <div class='poll' style='width:" . $rwidth . "px;'>
            <div class='poll-content'>

              <div class='poll-question'>
              " . $vpolldata['question'] . "
              " . _condReturn($vpolldata['locked'] == 1, "<div>(" . $_lang['hcm.poll.locked'] . ")</div>") . "
              </div>

              " . $ranswers_code . "

            </div>
            </div>\n
            ";
                                } 
                            } 
                            break;
                        case"search":if (_search) {
                                $mresult = "
        <form action='index.php' method='get' class='searchform'>
        <input type='hidden' name='m' value='search' />
        <input type='hidden' name='root' value='1' />
        <input type='hidden' name='art' value='1' />
        <input type='text' name='q' class='q' /> <input type='submit' value='" . $_lang['mod.search.submit'] . "' />
        </form>
        ";
                            } 
                            break;
                    } 
                } else {
                    $mresult = "";
                } 
            } else {
                $mresult = "";
            } 
            $output .= $mresult;
        } 
        $output .= $input;
    } else {
        $output = $input;
    } 
    return$output;
} 
function _parsePath($path) {
    $path = _arrayRemoveValue(explode("/", trim($path, "/")), ".");
    $loop = true;
    while ($loop) {
        $moverindex = -1;
        for($i = count($path)-1;$i >= 0;$i--) {
            if ($path[$i] == "..") {
                $moverindex = $i;
                break;
            } 
        } 
        if ($moverindex != -1) {
            $collision = -1;
            for($i = $moverindex-1;$i >= 0;$i--) {
                if ($path[$i] != "..") {
                    $collision = $i;
                    break;
                } 
            } 
            if ($collision != -1) {
                $path = _arrayRemoveKey($path, $moverindex, true);
                $path = _arrayRemoveKey($path, $collision, true);
                $path = _arrayRemoveKey($path, -1);
            } else {
                $loop = false;
            } 
        } else {
            $loop = false;
        } 
    } 
    $output = implode("/", $path) . "/";
    if ($output == "/") {
        $output = "./";
    } 
    return$output;
} 
class Simple_BB_Code {
    var$tags = array('code' => 'span class=\'pre\'', 'b' => 'strong', 'i' => 'em', 'u' => 'span style="text-decoration:underline"', 'quote' => 'blockquote', 's' => 'span style="text-decoration: line-through"');
    var$mapped = array('url' => array('a', 'href', true), 'img' => array('img', 'src', false));
    var$tags_with_att = array('color' => array('font', 'color'), 'size' => array('font', 'size'), 'url' => array('a', 'href'));
    var$convert_newlines = true;
    var$auto_links = true;
    var$_code = '';
    function Simple_BB_Code($new = true, $parse = true, $links = true) {
        $this->convert_newlines = $new;
        $this->auto_links = $links;
    } 
    function parse($code) {
        $this->_code = $code;
        $this->_strip_html();
        $this->_parse_tags();
        $this->_parse_mapped();
        $this->_parse_tags_with_att();
        $this->_parse_links();
        $this->_convert_nl();
        return$this->_code;
    } 
    function _strip_html() {
        $this->_code = strip_tags($this->_code);
    } 
    function _convert_nl() {
        if ($this->convert_newlines) {
            $this->_code = nl2br($this->_code);
        } 
    } 
    function _parse_tags() {
        foreach($this->tags as$old => $new) {
            $ex = explode(' ', $new);
            $this->_code = preg_replace('/\[' . $old . '\](.+?)\[\/' . $old . '\]/is', '<' . $new . '>$1</' . $ex[0] . '>', $this->_code);
        } 
    } 
    function _parse_mapped() {
        foreach($this->mapped as$tag => $data) {
            $reg = '/\[' . $tag . '\](.+?)\[\/' . $tag . '\]/is';
            if ($data[2]) {
                $this->_code = preg_replace($reg, '<' . $data[0] . ' ' . $data[1] . '="$1">$1</' . $data[0] . '>', $this->_code);
            } else {
                $this->_code = preg_replace($reg, '<' . $data[0] . ' ' . $data[1] . '="$1" alt="img" />', $this->_code);
            } 
        } 
    } 
    function _parse_tags_with_att() {
        foreach($this->tags_with_att as$tag => $data) {
            $this->_code = preg_replace('/\[' . $tag . '=(.+?)\](.+?)\[\/' . $tag . '\]/is', '<' . $data[0] . ' ' . $data[1] . '="$1">$2</' . $data[0] . '>', $this->_code);
        } 
    } 
    function _parse_links() {
        if ($this->auto_links) {
            $this->_code = preg_replace('/([^"])(http:\/\/|ftp:\/\/)([^\s,]*)/i', '$1<a href="$2$3" target="_blank">$2$3</a>', $this->_code);
            $this->_code = preg_replace('/([^"])([A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4})/i', '$1<a href="mailto:$2">$2</a>', $this->_code);
        } 
    } 
} 
function _parsePost($input) {
    $output = $input;
    if (_bbcode) {
        $bb = new Simple_BB_Code();
        $output = $bb->parse($output);
    } 
    if (_smileys) {
        $smileys_tags = array("*1*", "*2*", "*3*", "*4*", "*5*", "*6*", "*7*", "*8*", "*9*", "*10*");
        $smileys_imgs = array("<img class='post-smiley' alt='1' src='" . _indexroot . "templates/" . _template . "/images/smileys/1.gif' />", "<img class='post-smiley' alt='2' src='" . _indexroot . "templates/" . _template . "/images/smileys/2.gif' />", "<img class='post-smiley' alt='3' src='" . _indexroot . "templates/" . _template . "/images/smileys/3.gif' />", "<img class='post-smiley' alt='4' src='" . _indexroot . "templates/" . _template . "/images/smileys/4.gif' />", "<img class='post-smiley' alt='5' src='" . _indexroot . "templates/" . _template . "/images/smileys/5.gif' />", "<img class='post-smiley' alt='6' src='" . _indexroot . "templates/" . _template . "/images/smileys/6.gif' />", "<img class='post-smiley' alt='7' src='" . _indexroot . "templates/" . _template . "/images/smileys/7.gif' />", "<img class='post-smiley' alt='8' src='" . _indexroot . "templates/" . _template . "/images/smileys/8.gif' />", "<img class='post-smiley' alt='9' src='" . _indexroot . "templates/" . _template . "/images/smileys/9.gif' />", "<img class='post-smiley' alt='10' src='" . _indexroot . "templates/" . _template . "/images/smileys/10.gif' />");
        $output = str_replace($smileys_tags, $smileys_imgs, $output);
    } 
    return$output;
} 
function _postAccess($post) {
    if ($post['author'] != -1) {
        $author = mysql_fetch_array(mysql_query("SELECT id,`group` FROM `" . _mysql_prefix . "-users` WHERE id=" . $post['author']));
        $level = mysql_fetch_array(mysql_query("SELECT level FROM `" . _mysql_prefix . "-groups` WHERE id=" . $author['group']));
        $level = $level['level'];
    } else {
        $level = 0;
    } 
    if (_loginindicator and(_loginright_level > $level or _loginid == $author['id'])and($post['time'] + _postadmintime > time()or _loginright_unlimitedpostaccess)) {
        return true;
    } else {
        return false;
    } 
} 
function _publicAccess($public) {
    if ($public == 1 or($public == 0 and _loginindicator)) {
        return true;
    } else {
        return false;
    } 
} 
function _removePHP($content) {
    if (!_loginright_adminhcmphp) {
        return preg_replace("|(.*)\[hcm\]php(.*)|ix", "$1$2", $content);
    } else {
        return$content;
    } 
} 
function _removeSlashesFromEnd($string) {
    while (mb_substr($string, -1) == "/") {
        $string = mb_substr($string, 0, mb_strlen($string)-1);
    } 
    return$string;
} 
function _restoreValue($name, $else = null, $noautoparam = false) {
    if (!$noautoparam) {
        $autoparam_start = " value='";
        $autoparam_end = "'";
    } else {
        $autoparam_start = "";
        $autoparam_end = "";
    } 
    if (isset($_POST[$name])) {
        return$autoparam_start . _htmlStr($_POST[$name]) . $autoparam_end;
    } else {
        if ($else != null) {
            return$autoparam_start . _htmlStr($else) . $autoparam_end;
        } 
    } 
} 
function _restoreValueByGet($name, $else = null) {
    if (isset($_GET['_formData'][$name])) {
        return" value='" . _htmlStr($_GET['_formData'][$name]) . "'";
    } else {
        if ($else != null) {
            return" value='" . _htmlStr($else) . "'";
        } 
    } 
} 
function _resultPaging($url, $limit, $table, $conditions = "1", $linksuffix = "", $param = "s") {
    global$_lang;
    $count = mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-" . $table . "` WHERE " . $conditions), 0);
    if ($count == 0) {
        $count = 1;
    } 
    if (isset($_GET[$param])) {
        $s = abs(intval($_GET[$param])-1);
    } else {
        $s = 0;
    } 
    $pages = ceil($count / $limit);
    if ($s + 1 > $pages) {
        $s = 0;
    } 
    $start = $s * $limit;
    $beginpage = $s + 1 - _showpages;
    if ($beginpage < 1) {
        $endbonus = abs($beginpage) + 1;
        $beginpage = 1;
    } else {
        $endbonus = 0;
    } 
    $endpage = $s + 1 + _showpages + $endbonus;
    if ($endpage > $pages) {
        $beginpage -= $endpage - $pages;
        if ($beginpage < 1) {
            $beginpage = 1;
        } 
        $endpage = $pages;
    } 
    if (mb_substr_count($url, "?") == 0) {
        $url .= "?";
    } else {
        $url .= "&amp;";
    } 
    $paging = "<span>";
    for($x = $beginpage;$x <= $endpage;$x++) {
        if ($x == $s + 1) {
            $class = " class='act'";
        } else {
            $class = "";
        } 
        $paging .= "<a href='" . $url . $param . "=" . $x . $linksuffix . "'" . $class . ">" . $x . "</a>";
        if ($x != $endpage) {
            $paging .= " ";
        } 
    } 
    $paging .= "</span>";
    if ($s + 1 != 1) {
        $paging = "<a href='" . $url . $param . "=" . ($s) . $linksuffix . "'>&laquo; " . $_lang['global.previous'] . "</a>&nbsp;&nbsp;" . $paging;
    } 
    if ($s > _showpages) {
        $paging = "<a href='" . $url . $param . "=1" . $linksuffix . "' title='" . $_lang['global.first'] . "'>1</a> ... " . $paging;
    } 
    if ($s + 1 != $pages) {
        $paging .= "&nbsp;&nbsp;<a href='" . $url . $param . "=" . ($s + 2) . $linksuffix . "'>" . $_lang['global.next'] . " &raquo;</a>";
    } 
    if ($s + 1 < $pages - _showpages) {
        $paging .= " ... <a href='" . $url . $param . "=" . $pages . $linksuffix . "' title='" . $_lang['global.last'] . "'>" . $pages . "</a>";
    } 
    $paging = "<div class='paging'>" . $_lang['global.paging'] . ":&nbsp;&nbsp;" . $paging . "</div>";
    return array($paging, "LIMIT " . $start . ", " . $limit, $s + 1, $pages);
} 
function _resultPagingGetItemPage($limit, $table, $conditions = "1") {
    $count = mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-" . $table . "` WHERE " . $conditions), 0);
    return intval($count / $limit) + 1;
} 
function _returnHeader() {
    if (isset($_GET['_return'])and$_GET['_return'] != "") {
        $_GET['_return'] = urldecode($_GET['_return']);
        if (preg_match("|^index.php\?m=(.*)|", $_GET['_return'])) {
            $_GET['_return'] = "";
        } 
        header("location: " . _indexroot . $_GET['_return']);
        exit;
    } else {
        if (isset($_SERVER['HTTP_REFERER'])and$_SERVER['HTTP_REFERER'] != "") {
            header("location: " . $_SERVER['HTTP_REFERER']);
            exit;
        } else {
            header("location: " . _indexroot);
            exit;
        } 
    } 
} 
function _safeStr($input) {
    if (get_magic_quotes_gpc() == 1) {
        return mysql_escape_string(stripslashes($input));
    } else {
        return mysql_escape_string($input);
    } 
} 
function _sectionOutput($id) {
    global$_lang;
    $query = mysql_fetch_array(mysql_query("SELECT * FROM `" . _mysql_prefix . "-root` WHERE id=" . $id));
    $content = _parseHCM($query['content']);
    $title = $query['title'];
    if ($query['var1'] == 1 and _comments) {
        $content .= _commentsOutput(1, $id);
    } 
    return array($content, $title);
} 
function _slcDecode($string) {
    $output = "";
    $string = @gzinflate(@base64_decode(@strrev($string)));
    $nums = explode(".", $string);
    $x = 0;
    foreach($nums as$char) {
        $output .= chr($char - $x);
        $x++;
    } 
    return$output;
} 
function _slcEncode($string) {
    $output = "";
    $len = mb_strlen($string);
    for($x = 0;$x < $len;$x++) {
        $output .= ord(mb_substr($string, $x, 1)) + $x . ".";
    } 
    $output = trim($output, ".");
    $output = @strrev(@base64_encode(@gzdeflate($output)));
    return$output;
} 
function _systemFailure($msg, $customtitle = false) {
    if ($customtitle == false) {
        global$_lang;
        $title = $_lang['global.error'];
    } else {
        $title = $customtitle;
    } 
    echo"<hr />\n<h1 style='color:#ff0000;'>" . $title . "</h1>\n<p>$msg</p>\n<hr />";
    exit;
} 
function _templateBoxes($column = 1) {
    $output = "\n";
    if (!_notpublicsite or _loginindicator) {
        if (_loginindicator) {
            $public = "";
        } else {
            $public = " AND public=1";
        } 
        if (_template_boxes_parent != "") {
            $output .= "<" . _template_boxes_parent . ">\n";
        } 
        $query = mysql_query("SELECT title,content FROM `" . _mysql_prefix . "-boxes` WHERE visible=1 AND `column`=" . $column . $public . " ORDER BY ord");
        while ($item = mysql_fetch_array($query)) {
            $title = "<" . _template_boxes_title . " class='box-title'>" . $item['title'] . "</" . _template_boxes_title . ">\n";
            if (_template_boxes_title_inside == 0 and$title != "") {
                $output .= $title;
            } 
            if (_template_boxes_item != "") {
                $output .= "<" . _template_boxes_item . " class='box-item'>\n";
            } 
            if (_template_boxes_title_inside == 1 and$title != "") {
                $output .= $title;
            } 
            $output .= _parseHCM($item['content']);
            if (_template_boxes_item != "") {
                $output .= "\n</" . _template_boxes_item . ">";
            } 
            if (_template_boxes_bottom == 1) {
                $output .= "<" . _template_boxes_item . " class='box-bottom'></" . _template_boxes_item . ">\n\n";
            } else {
                $output .= "\n\n";
            } ;
        } 
        if (_template_boxes_parent != "") {
            $output .= "</" . _template_boxes_parent . ">\n";
        } 
    } 
    echo$output;
} 
function _templateContent() {
    echo _indexOutput_content;
} 
function _templateHead() {
    global$_lang;
    echo'<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<meta name="keywords" content="' . _keywords . '" />
<meta name="description" content="' . _description . '" />
<meta name="author" content="' . _author . '" />
<meta name="generator" content="SunLight CMS ' . _systemversion . '" />
<meta name="robots" content="index, follow" />
<link href="' . _indexroot . 'templates/' . _template . '/style.css" type="text/css" rel="stylesheet" />';
    if (_lightbox) {
        echo'
<link rel="stylesheet" href="' . _indexroot . 'remote/lightbox/style.css" type="text/css" media="screen" />
<script type="text/javascript" src="' . _indexroot . 'remote/lightbox/prototype.js"></script>
<script type="text/javascript" src="' . _indexroot . 'remote/lightbox/scriptaculous.js?load=effects"></script>
<script type="text/javascript" src="' . _indexroot . 'remote/lightbox/lightbox.js"></script>';
    } 
    if (_rss) {
        echo'
<link rel="alternate" type="application/rss+xml" href="' . _indexroot . 'remote/rss.php?tp=4&amp;id=-1" title="' . $_lang['rss.recentarticles'] . '" />
<link rel="alternate" type="application/rss+xml" href="' . _indexroot . 'remote/rss.php?tp=5&amp;id" title="' . $_lang['rss.recentposts'] . '" />';
    } 
    echo'
<script type="text/javascript" src="' . _indexroot . 'remote/javascript.php"></script>
<title>' . _title . ' ' . _titleseparator . ' ' . _indexOutput_title . '</title>
';
} 
function _templateLinks() {
    global$_lang;
    echo"<a href='http://sunlight-cms.net/'>SunLight CMS</a> | <a href='" . _indexroot . "admin/index.php'>" . $_lang['admin.link'] . "</a>";
} 
function _templateMenu($ord_start = null, $ord_end = null) {
    global$shid_total;
    $output = "";
    if (!_notpublicsite or _loginindicator) {
        if ($ord_start === null or$ord_end === null) {
            $ord_limit = "";
        } else {
            $ord_limit = " AND ord>=" . intval($ord_start) . " AND ord<=" . intval($ord_end);
        } 
        $query = mysql_query("SELECT id,type,title,var1,var2 FROM `" . _mysql_prefix . "-root` WHERE visible=1 AND intersection=-1 AND type!=4" . $ord_limit . " ORDER BY ord");
        $output .= "<" . _template_menu_parent . " class='menu'>";
        $firstclass = " class='first'";
        while ($item = mysql_fetch_array($query)) {
            if (!($item['type'] == 7 and$item['var2'] == 1)) {
                if ($item['id'] == _indexOutput_pid) {
                    $class = " class='act'";
                } else {
                    $class = "";
                } 
                if ($item['type'] == 6 and$item['var1'] == 1) {
                    $target = " target='_blank'";
                } else {
                    $target = "";
                } 
                $link = "<a href='" . _linkRoot($item['id']) . "'" . $class . $target . ">" . $item['title'] . "</a>";
            } else {
                $shid_total += 1;
                $shid = $shid_total;
                $link = "
        <a href='" . _linkRoot($item['id']) . "' class='hs_closed' onclick=\"return _syshse('sh" . $shid . "', this)\">" . $item['title'] . "</a>
        <ul class='hs_content' id='sh" . $shid . "'>
        ";
                $iquery = mysql_query("SELECT id,title FROM `" . _mysql_prefix . "-root` WHERE intersection=" . $item['id'] . " AND visible=1 ORDER BY ord");
                while ($iitem = mysql_fetch_array($iquery)) {
                    if ($iitem['id'] == _indexOutput_pid) {
                        $class = " class='act'";
                    } else {
                        $class = "";
                    } 
                    $link .= "<li><a href='" . _linkRoot($iitem['id']) . "'" . $class . ">" . $iitem['title'] . "</a></li>";
                } 
                $link .= "</ul>";
            } 
            $output .= "<" . _template_menu_child . $firstclass . ">" . $link . "</" . _template_menu_child . ">";
            if ($firstclass != "") {
                $firstclass = "";
            } 
        } 
        $output .= "</" . _template_menu_parent . ">";
    } 
    return$output;
} 
function _templateTitle() {
    echo _indexOutput_title;
} 
function _templateUserMenu($echo = true) {
    global$_lang;
    $output = "";
    if (_template_usermenu_parent != "") {
        $output .= "<" . _template_usermenu_parent . ">";
    } 
    if (!_loginindicator) {
        $output .= _template_usermenu_item_start . "<a href='" . _indexroot . "index.php?m=login'>" . $_lang['usermenu.login'] . "</a>" . _template_usermenu_item_end;
        if (_registration) {
            $output .= _template_usermenu_item_start . "<a href='" . _indexroot . "index.php?m=reg'>" . $_lang['usermenu.registration'] . "</a>" . _template_usermenu_item_end;
        } 
    } else {
        if (_messages) {
            $messages_count = mysql_result(mysql_query("SELECT COUNT(*) FROM `" . _mysql_prefix . "-messages` WHERE receiver=" . _loginid . " AND readed=0"), 0);
            if ($messages_count != 0) {
                $messages_count = " [" . $messages_count . "]";
            } else {
                $messages_count = "";
            } 
            $output .= _template_usermenu_item_start . "<a href='" . _indexroot . "index.php?m=messages'>" . $_lang['usermenu.messages'] . $messages_count . "</a>" . _template_usermenu_item_end;
        } 
        $output .= _template_usermenu_item_start . "<a href='" . _indexroot . "index.php?m=settings'>" . $_lang['usermenu.settings'] . _condReturn(_template_usermenu_showusername, " [" . _loginname . "]") . "</a>" . _template_usermenu_item_end;
        $output .= _template_usermenu_item_start . "<a href='" . _indexroot . "remote/logout.php?_return=" . urlencode(_indexOutput_url) . "'>" . $_lang['usermenu.logout'] . _condReturn(_template_usermenu_showusername, " [" . _loginname . "]") . "</a>" . _template_usermenu_item_end;
    } 
    if (_ulist and(!_notpublicsite or _loginindicator)) {
        $output .= _template_usermenu_item_start . "<a href='" . _indexroot . "index.php?m=ulist'>" . $_lang['usermenu.ulist'] . "</a>" . _template_usermenu_item_end;
    } 
    if (_template_usermenu_parent != "") {
        $output .= "</" . _template_usermenu_parent . ">";
    } 
    if (_template_usermenu_trim == 1) {
        $output = trim($output);
        $output = trim($output, _template_usermenu_item_start);
        $output = trim($output, _template_usermenu_item_end);
    } 
    if ($echo) {
        echo$output;
    } else {
        return$output;
    } 
} 
function _uniForm($id, $vars = array(), $notitle = false) {
    global$_lang;
    $content = "";
    $title = "";
    switch ($id) {
        case"login":$title = $_lang['login.title'];
            if (isset($_GET['r'])) {
                switch ($_GET['r']) {
                    case 0:$content .= _formMessage(2, $_lang['login.failure']);
                        break;
                    case 1:if (_loginindicator and!_administration) {
                            $content .= _formMessage(1, $_lang['login.success']);
                        } 
                        break;
                    case 2:if (!_loginindicator) {
                            $content .= _formMessage(2, $_lang['login.blocked.message']);
                        } 
                        break;
                    case 3:if (!_loginindicator) {
                            $content .= _formMessage(3, $_lang['login.securitylogout']);
                        } 
                        break;
                    case 4:if (!_loginindicator) {
                            $content .= _formMessage(1, $_lang['login.selfremove']);
                        } 
                        break;
                    case 5:if (!_loginindicator) {
                            $content .= _formMessage(2, str_replace(array("*1*", "*2*"), array(_maxloginattempts, _maxloginexpire / 60), $_lang['login.attemptlimit']));
                        } 
                        break;
                } 
            } 
            if (!_loginindicator) {
                $redirparam = "<input type='hidden' name='redir' value='" . $vars['return'] . "' />";
                $redirparam .= "<input type='hidden' name='redir_path' value='" . $vars['returnpath'] . "' />";
                $content .= _formOutput("login_form", _indexroot . "remote/login.php" . _condReturn($vars['return'] != "admin"and$vars['return'] != "mod", "?_return=" . urlencode($vars['returnpath'])), array(array($_lang['login.username'], "<input type='text' name='username' class='inputsmall'" . _restoreValueByGet("username") . " maxlength='24' />" . $redirparam), array($_lang['login.password'], "<input type='password' name='password' class='inputsmall' />")), array("username", "password"), $_lang['global.login']);
                if (_administration != 1) {
                    $content .= "<p>" . _condReturn(_registration, "<a href='index.php?m=reg'>" . $_lang['mod.reg'] . " &gt;</a>") . "</p>";
                } 
            } else {
                $content .= "<p>" . $_lang['login.ininfo'] . " " . _loginname . " - <a href='" . _indexroot . "remote/logout.php'>" . $_lang['usermenu.logout'] . "</a>.</p>";
            } 
            break;
        case"notpublic":$form = _uniForm("login", array('return' => -1, 'returnpath' => urlencode(_indexOutput_url)), true);
            if (!isset($vars['notpublicsite'])) {
                $vars['notpublicsite'] = false;
            } 
            $content = "<p>" . _condReturn($vars['notpublicsite'] != true, $_lang['notpublic.p'], $_lang['notpublic.p2']) . "</p>" . $form[0];
            $title = $_lang['notpublic.title'];
            break;
        case"postform":$title = "";
            $notitle = true;
            $inputs = array();
            $captcha = _captchaInit();
            $content = _jsLimitLength(3072, "postform", "text");
            if (_loginindicator == 0) {
                $inputs[] = array($_lang['posts.guestname'], "<input type='text' name='guest' class='inputsmall' />");
            } 
            if ($vars['xhome'] == -1) {
                $inputs[] = array($_lang['posts.subject'], "<input type='text' name='subject' class='inputsmall' maxlength='22' />");
            } 
            $inputs[] = $captcha[1];
            $inputs[] = array($_lang['posts.text'], "<textarea name='text' class='areamedium' rows='5' cols='33'></textarea><input type='hidden' name='_posttype' value='" . $vars['posttype'] . "' /><input type='hidden' name='_posttarget' value='" . $vars['posttarget'] . "' /><input type='hidden' name='_xhome' value='" . $vars['xhome'] . "' />" . $captcha[0], true);
            $content .= _formOutput('postform', _addGetToLink(_indexroot . "remote/post.php", "_return=" . urlencode(_indexOutput_url) . "#posts"), $inputs, array("text"), null, _getPostformControls("postform", "text"));
            break;
    } 
    if ((_template_autoheadings == 1 or _administration == 1)and$notitle == false) {
        $content = "<h1>$title</h1>" . $content;
    } 
    return array($content, $title);
} 
function _validateEmail($email) {
    if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) {
        return false;
    } 
    $email_array = explode("@", $email);
    $local_array = explode(".", $email_array[0]);
    for($i = 0;$i < sizeof($local_array);$i++) {
        if (!ereg("^(([A-Za-z0-9!#$%&#038;'*+/=?^_`{|}~-][A-Za-z0-9!#$%&#038;'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$", $local_array[$i])) {
            return false;
        } 
    } 
    if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1])) {
        $domain_array = explode(".", $email_array[1]);
        if (sizeof($domain_array) < 2) {
            return false;
        } 
        for($i = 0;$i < sizeof($domain_array);$i++) {
            if (!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$", $domain_array[$i])) {
                return false;
            } 
        } 
    } 
    return true;
} 
function _validateURL($uri) {
    return preg_match('/^(http|https|ftp):\/\/[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,6}((:[0-9]{1,5})?\/.*)?$/i', $uri);
} 
function _wsTrim($string) {
    return preg_replace("|  +|", " ", preg_replace("|(\r\n){3,}|", "\r\n\r\n", trim($string)));
} 
?>